TeamTalk 5 Java DLL Version 5.19A

ChangeLog

This section contains the list of new features and API changes in TeamTalk SDK releases.

TeamTalk 5 SDK v. 5.19a release, August 5th 2025

- Bug fixes in v5.19a

TeamTalk 5 SDK v. 5.18a release, May 5th 2025

- New features in v5.18a
  - Last login time on user account
  - WebRTC updated to r6818
- API changes in v5.18a

TeamTalk 5 SDK v. 5.15a release, December 19th 2023

- New features in v5.15a
  - PulseAudio support
  - User right for sending text messages
- API changes in v5.15a

TeamTalk 5 SDK v. 5.14a release, August 16th 2023

- New features in v5.14a
  - Time Out Timer for Voice and Media Streams
- API changes in v5.14a

TeamTalk 5 SDK v. 5.13a release, May 8th 2023

- New features in v5.13a
  - Encrypted client connect is no longer blocking

TeamTalk 5 SDK v. 5.12a release, December 21st 2022

- Bug Fixes in v5.12a

TeamTalk 5 SDK v. 5.11a release, October 2nd 2022

- New Features in v5.11a
- Bug Fixes in v5.11a
- API change in v5.11a

TeamTalk 5 SDK v. 5.9a release, April 2nd 2022

- New features in v5.9a
  - Configurable server logging
  - Create combined TextMessage
  - Configurable delay in queued conversations (solo transmit)
- API change in v5.9a

TeamTalk 5 SDK v. 5.8b release, September 7th 2021

- New features in v5.8b
  - Timestamp on UserAccount-struct
  - Timestamp on RemoteFile-struct
- API change in v5.8b

TeamTalk 5 SDK v. 5.8a release, June 24th 2021

- New features in v5.8a
  - Store audio from multiple stream types
- API change in v5.8a

TeamTalk 5 SDK v. 5.7a release, March 4th 2021

- New features in v5.7a
  - WebRTC Audio Preprocessor
  - Classroom support for channel text messages
  - Hidden channels
  - Client/Server peer verification for encryption
  - Jitter buffer for voice stream
  - Stream OPUS .ogg files on Windows
  - Multiple encryption contexts for TeamTalk server
- API changes in v5.7a

TeamTalk 5 SDK v. 5.6a release, August 9th 2020

- New features in v5.6a
  - Android sound device for enabling voice communication mode
  - Enable platform specific sound device effects
  - Specify sample rate and audio channels for shared sound device
  - Perform sound loopback test using audio preprocessor and sound device effects
  - Sound preprocessor selection
- API changes in v5.6a
  - Compatibility issue with TeamTalk v5.5 and previous

TeamTalk 5 SDK v. 5.5a release, April 13 2020

- New features in v5.5a
  - Shared audio input/output device
  - Playback media file
  - Control media file playback when
  - nTxIntervalMSec increased to 500 msec
  - OPUS codec frame size selection
  - Access muxed audio stream
  - Inject audio into channel (replace voice input)
  - Configure TCP and UDP keep alive properties
  - Record audio from multiple channels
  - Connect to encrypted TeamTalk Professional servers
  - TeamTalk 5 shared C-API library for Android
- API changes in v5.5a

TeamTalk 5 SDK v. 5.4a release, June 25th 2019

- New features in v5.4a
- API changes in v5.4a
- Bug fixes in v5.4a

TeamTalk 5 SDK v. 5.3b release, November 11th 2018

- API changes in v5.3b

TeamTalk 5 SDK v. 5.3a release, April 14th 2018

- API changes in v5.3a

TeamTalk 5 SDK v. 5.2d release, June 24th 2017

- Bugfixes in v5.2d

TeamTalk 5 SDK v. 5.2c release, May 8th 2017

- New features in v5.2c
  - Virtual sound device
  - Transmission queue in CHANNEL_SOLO_TRANSMIT
  - Server callbacks for TeamTalkBase.DoChangeNickname() and TeamTalkBase.DoChangeStatus()
  - OpenSSL again dynamically linked in Linux distributions
  - Daemon scripts included for TeamTalk servers
- API changes in v5.2c
  - TeamTalk class renamed to TeamTalkBase

TeamTalk 5 SDK v. 5.2b release, Jan 30th 2017

- API changes in v.5.2b
  - TeamTalk Server API for .NET
- Bugfixes in v5.2b

TeamTalk 5 SDK v. 5.2a release, January 8th 2017

- New features in v5.2a
  - TeamTalk Server API with System ID
  - Voice-Processing I/O Unit for iOS
  - Video4Linux2 (V4L2) support on Linux
  - AVFoundation replaces QTkit on Mac OS
  - Dependencies on Linux has been reduced
  - Sound Preprocessing (Automatic gain control) for iOS
  - TeamTalk for Android now uses Android Studio
  - Store audio in .ogg format
- API changes in v5.2a
  - Deadline for WebM video encoder
  - Get software client used by peer
  - Limit access to TeamTalk server to one software client
- Bugfixes in v5.2a

TeamTalk 5 SDK v. 5.1c release, February 29th 2016

- API changes in v. 5.1c

TeamTalk 5 SDK v. 5.1b release, October 3rd 2015

- New features in v. 5.1b
  - Record own voice stream to separate file
  - TeamTalk JNI DLL for Windows

TeamTalk 5 SDK v. 5.1a release, June 13th 2015

- New Features in v. 5.1a release
  - TeamTalk 5 Server API
  - TeamTalk 5 Java DLL
  - TeamTalk 5 SDK for iOS

TeamTalk 5 SDK v. 5.0a release, March 15th 2015

- New features in v. 5.0a
  - Updated event handling
  - WebM replaces Theora video codec
  - OPUS replaces CELT audio codec
  - AES encryption replaces Blowfish
  - New stream type for media files
  - User rights now moved to user account
  - Audio codec bitrate limit moved to user account
  - Max channels limited to 4000
  - Peer to peer support has been removed
  - Channels can be renamed
  - Daemon script for server included
  - Audio configuration no longer forced by channel
  - Default server config file renamed to tt5srv.xml
  - Server statistics updated
  - Non-encrypted mode in Professional server
- API changes in v. 5.0a
  - Structures
    - New structs:
    - Renamed/modified structs:
    - Removed structs
  - Enumerations
    - New enumerations
    - Renamed/modified enumerations
    - Removed enumerations:
  - Events
    - New events:
    - Renamed/modified events:
    - Removed events
  - Methods
    - New methods
    - Renamed/modified methods
    - Removed methods

TeamTalk 4 SDK v. 4.6b release, June 28th 2014

- New features in v. 4.6b

TeamTalk 4 SDK v. 4.6a release, February 20th 2014

- New features in v. 4.6a
  - Desktop Access
- API Changes in v4.6a

TeamTalk 4 SDK v. 4.5a release, May 12th 2013

- New features in v. 4.5a
  - Stream Media Files to Channel
  - Login Attempt Limit
  - Ban user by IP-address
- API Changes in v4.5a

TeamTalk 4 SDK v. 4.4a release, September 25th 2012

- New features in v. 4.4a
  - Support for Windows Audio Session
  - Restart Sound System
  - Automatic resampling of unsupported sample rates
  - Operator receive-only channel type
  - Encrypted client (Pro-Edition) can connect to non-encrypted servers
  - Unicode video device names
- API Changes in v4.4a

TeamTalk 4 SDK v. 4.3a release, March 18th 2012

- New features in v. 4.3a
  - Share Desktop Applications
  - Join channel after login
  - Automatically become channel operator
  - Custom message type
  - Query maximum UDP packet size
  - Access raw audio data
  - Get name of file being recorded to
  - Reset recorded audio file
  - See own video stream
  - Free-for-all option in classrooms
- API Changes in v4.3a

TeamTalk 4 SDK v. 4.2a release, November 1st 2011

- New features in v. 4.2a
  - Muxed audio files
  - Windows XP/Vista/7 Firewall
  - Modify "talking" delay
  - VBR audio codecs
  - CELT updated to version 0.11
  - IPv6 support (Windows 2000 no longer supported)
- API Changes in v4.2a

TeamTalk 4 SDK v. 4.1a release, October 30th 2010

- New Features in v. 4.1a release
  - Removed Microsoft C Runtime dependency
  - Mac OS X and Windows Mobile platforms
  - Echo Cancellation
  - Classroom channel-type
  - Channel based audio configuration
  - Server Statistics
  - Simpler video extraction
- API Changes in v4.1a

TeamTalk 4 SDK v. 4.0c release, March 7th 2010

- New Features in v. 4.0c
  - Note-field and user-data for user accounts
  - Get "my" User Account
  - Extract all Users on the Server
- API Changes in v4.0c
- Bug fixes in v. 4.0c

TeamTalk 4 SDK v. 4.0a release, November 22nd 2009

- New Features in v. 4.0a
  - Video Capturing from WebCams
  - User Accounts
  - Track Command Completion
  - Improved P2P Connections
  - Support for CELT audio codec
- API Changes in v. 4.0a

# TeamTalk 5 SDK v. 5.19a release, August 5th 2025

## Bug fixes in v5.19a

TeamTalk server executable has fixed a security issue where a reused channel ID could give operator access to someone who previously had that channel ID.

# TeamTalk 5 SDK v. 5.18a release, May 5th 2025

## New features in v5.18a

### Last login time on user account

A BearWare.UserAccount now contains a field `szLastLoginTime` which shows the last time a user logged in.

### WebRTC updated to r6818

WebRTC was previously based on r4332 but has now been updated to r6818. This has unfortunately caused the BearWare.WebRTCAudioPreprocessor struct to become incompatible with the struct specified previous releases. Basically level estimation and voice detecting using WebRTC is no longer supported.

## API changes in v5.18a

- New field `szLastLoginTime` in #UserAccount
- Removed field `voicedetetion` from #WebRTCAudioPreprocessor
- Removed field `levelestimation` from #WebRTCAudioPreprocessor
- Modified field `adaptivedigital` in #WebRTCAudioPreprocessor

# TeamTalk 5 SDK v. 5.15a release, December 19th 2023

## New features in v5.15a

### PulseAudio support

PulseAudio sound system is now supported in the TeamTalk SDKs for Ubuntu 22 and Raspbian.

See also
  SoundSystem.SOUNDSYSTEM_PULSEAUDIO.

### User right for sending text messages

It is now possible to disable the ability to send private and channel text messages using UserRight.USERRIGHT_TEXTMESSAGE_USER and UserRight.USERRIGHT_TEXTMESSAGE_CHANNEL.

## API changes in v5.15a

- New field `szOwner` in BearWare.BannedUser
- New enum value `ClientError.CMDERR_MAX_FILETRANSFERS_EXCEEDED` in ClientError
- New enum value `TTType.__SOUNDDEVICEEFFECTS` in TTType
- New enum value `TTType.__DESKTOPWINDOW` in TTType
- New enum value `TTType.__ABUSEPREVENTION` in TTType
- New enum value `SoundSystem.SOUNDSYSTEM_PULSEAUDIO` in SoundSystem
- New enum value `AudioFileFormat.AFF_MP3_320KBIT_FORMAT` in AudioFileFormat
- New enum value `UserRight.USERRIGHT_TEXTMESSAGE_USER` in UserRight
- New enum value `UserRight.USERRIGHT_TEXTMESSAGE_CHANNEL` in UserRight

# TeamTalk 5 SDK v. 5.14a release, August 16th 2023

## New features in v5.14a

### Time Out Timer for Voice and Media Streams

The maximum duration (in milliseconds) for a voice or media stream to be active can now be specified in BearWare.Channel fields `nTimeOutTimerVoiceMSec` and `nTimeOutTimerMediaFileMSec`. This can be used to ensure that a single user does not block voice transmission to a channel when e.g. using BearWare.ChannelType.CHANNEL_SOLO_TRANSMIT.

## API changes in v5.14a

- New field `nTimeOutTimerVoiceMSec` in BearWare.Channel
- New field `nTimeOutTimerMediaFileMSec` in BearWare.Channel

# TeamTalk 5 SDK v. 5.13a release, May 8th 2023

## New features in v5.13a

### Encrypted client connect is no longer blocking

The call to BearWare.TeamTalkBase.Connect() is no longer a blocking call when using encryption.

# TeamTalk 5 SDK v. 5.12a release, December 21st 2022

## Bug Fixes in v5.12a

This release fixes a crash issue in the TeamTalk server when a user performs a channel ban on a user who is not in a channel.

# TeamTalk 5 SDK v. 5.11a release, October 2nd 2022

## New Features in v5.11a

Here's the list of new features in TeamTalk SDK v5.11a:

- TeamTalk server restores classroom transmissions
- Standard Edition TeamTalk server (tt5srv) no longer depend on OpenSSL
- Professional Edition TeamTalk server (tt5prosrv) requires BearWare.dk WebLogin authentication to run
- Subscription changes are written to server's log file
- Password of operators are forwarded to operators and administrators
- Auto-operators can update channels they're not currently participating in
- Channel operator status is resumed after connection lost when using BearWare.dk WebLogin
- TeamTalk SDK now targets Ubuntu 22 instead of Ubuntu 18

## Bug Fixes in v5.11a

Here's the list of bug fixes in TeamTalk SDK v5.11a:

- Fixed issue where channel bans were no longer valid after channel is renamed
- Fixed time zone conversion in TeamTalk server when time zone is before UTC.

## API change in v5.11a

- New enum value TextMsgType `TextMsgType.MSGTYPE_NONE`.

# TeamTalk 5 SDK v. 5.9a release, April 2nd 2022

## New features in v5.9a

### Configurable server logging

It's now possible to change log levels while the TeamTalk server is running. Setup `uServerLogEvents` in BearWare.ServerProperties and issue BearWare.TeamTalkBase.DoUpdateServer(). `uServerLogEvents` is based on BearWare.ServerLogEvent.

### Create combined TextMessage

BearWare.TextMessage is limited to 511 characters but now it's possible to specify `bMore` on BearWare.TextMessage to denote that a text message is part of a combined message.

### Configurable delay in queued conversations (solo transmit)

A BearWare.ChannelType.CHANNEL_SOLO_TRANSMIT BearWare.Channel automatically switched to the next user after 500 msec of inactivity. This delay is now configurable using `nTransmitUsersQueueDelayMSec` on BearWare.Channel.

## API change in v5.9a

- New enum BearWare.ServerLogEvent
- New field `uServerLogEvents` in BearWare.ServerProperties
- New field `bMore` in BearWare.TextMessage
- New field `nTransmitUsersQueueDelayMSec` in BearWare.Channel

# TeamTalk 5 SDK v. 5.8b release, September 7th 2021

## New features in v5.8b

### Timestamp on UserAccount-struct

BearWare.UserAccount now includes a property that shows when it was last modified.

### Timestamp on RemoteFile-struct

BearWare.RemoteFile now includes a property that shows when it was uploaded.

## API change in v5.8b

- New field `szLastModified` on BearWare.UserAccount-struct.
- New field `szUploadTime` on BearWare.RemoteFile-struct

# TeamTalk 5 SDK v. 5.8a release, June 24th 2021

## New features in v5.8a

### Store audio from multiple stream types

Previously it was only possible to store audio from BearWare.StreamType.STREAMTYPE_VOICE to either a file or BearWare.AudioBlock. In TeamTalk v5.8a it's now possible to have the TeamTalk instance mix several stream types into a single audio stream.

To record multiple audio streams, i.e. BearWare.StreamType.STREAMTYPE_VOICE, BearWare.StreamType.STREAMTYPE_LOCALMEDIAPLAYBACK_AUDIO and BearWare.StreamType.STREAMTYPE_MEDIAFILE_AUDIO, use BearWare.TeamTalkBase.StartRecordingMuxedStreams(). The BearWare.StreamType can be OR'ed to mix the wanted combination.

To retrieve BearWare.AudioBlock with mixed audio use BearWare.TeamTalkBase.EnableAudioBlockEvent().

## API change in v5.8a

- New enum value BearWare.StreamType.STREAMTYPE_LOCALMEDIAPLAYBACK_AUDIO for BearWare.TeamTalkBase.InitLocalPlayback() playback.
- New field `uStreamTypes` on BearWare.AudioBlock denoting which streams were mixed into the BearWare.AudioBlock.
- New function BearWare.TeamTalkBase.StartRecordingMuxedStreams() to record multiple BearWare.StreamType to a single file.

# TeamTalk 5 SDK v. 5.7a release, March 4th 2021

## New features in v5.7a

### WebRTC Audio Preprocessor

Previously BearWare.SpeexDSP was the only support audio preprocessor for noise suppression, echo cancellation and automatic gain control (AGC). In TeamTalk v5.7 it's now possible to use WebRTC's audio preprocessor which work significantly better than the echo cancellor in SpeexDSP and platform echo cancellors supported through SoundDeviceFeature.SOUNDDEVICEFEATURE_AEC.

Read more about WebRTC's audio preprocessor using the BearWare.WebRTCAudioPreprocessor-struct.

### Classroom support for channel text messages

Previously it was only possible to control StreamType.STREAMTYPE_VOICE, StreamType.STREAMTYPE_MEDIAFILE, StreamType.STREAMTYPE_VIDEOCAPTURE and StreamType.STREAMTYPE_DESKTOP in a classroom using `transmitUsers` on BearWare.Channel-struct. Now StreamType.STREAMTYPE_CHANNELMSG has been added so it's also possible to enable/disable channel text messages sent through TeamTalkBase.DoTextMessage().

### Hidden channels

A new channel type ChannelType.CHANNEL_HIDDEN has been introduced which makes a channel invisible to users who do not have UserRight.USERRIGHT_VIEW_HIDDEN_CHANNELS. Users who cannot see the channel are still able to join it given that they know its name and password. Only users with UserRight.USERRIGHT_MODIFY_CHANNELS are able to create hidden channels.

Use TeamTalkBase.DoMakeChannel() or TeamTalkBase.DoJoinChannel() to create a hidden channel.

### Client/Server peer verification for encryption

Both client and server are now able to verify that the remote end is a valid user using TLS peer verification. Peer verfication is set up in BearWare.EncryptionContext and enable using TeamTalkBase.SetEncryptionContext() on the client and TeamTalkSrvBase.SetEncryptionContext() on the server.

### Jitter buffer for voice stream

Compensation for network jitter can now be enabled using BearWare.JitterConfig and activated using TeamTalkBase.SetUserJitterControl(). The jitter configuration allows a buffer to build up before playback starts. Remember to also increase the allowed buffer size by calling TeamTalkBase.SetUserAudioStreamBufferSize().

### Stream OPUS .ogg files on Windows

TeamTalkBase.StartStreamingMediaFileToChannel() now support OPUS .ogg files on Windows. This allows playback of files recorded using TeamTalkBase.SetUserMediaStorageDir() or TeamTalkBase.StartRecordingMuxedAudioFile().

### Multiple encryption contexts for TeamTalk server

Previously it was only possible to set one BearWare.EncryptionContext for all TeamTalk server instance, i.e. BearWare.TeamTalkSrvBase, but now each server instance can have its own by calling TeamTalkSrvBase.SetEncryptionContext().

## API changes in v5.7a

- New enum value SoundDeviceFeature.SOUNDDEVICEFEATURE_DEFAULTCOMDEVICE to denote default communication device on Windows.
- New struct BearWare.WebRTCAudioPreprocessor for configurating WebRTC audio preprocessor.
- New enum value AudioPreprocessorType.WEBRTC_AUDIOPREPROCESSOR for BearWare.WebRTCAudioPreprocessor.
- New field `webrtc` in BearWare.AudioPreprocessor for BearWare.WebRTCAudioPreprocessor.
- New enum value StreamType.STREAMTYPE_CHANNELMSG for enable/disabling channel text messages.
- New enum value ChannelType.CHANNEL_HIDDEN for creating hidden channels. See Hidden channels.
- New enum value UserRight.USERRIGHT_VIEW_HIDDEN_CHANNELS for allowing a user to view channels of type ChannelType.CHANNEL_HIDDEN.
- New field `nSoundInputDeviceDelayMSec` in BearWare.ClientStatistics for showing audio device delay.
- New enum value ClientError.CMDERR_CHANNEL_CANNOT_BE_HIDDEN for given error when a channel cannot be hidden.
- New event TeamTalkBase.OnUserFirstVoiceStreamPacket() for sending event when new voice stream starts.
- New struct BearWare.JitterConfig for configuring network jitter compensation. See Jitter buffer for voice stream.
- New function TeamTalkBase.SetUserJitterControl() for enabling BearWare.JitterConfig on a BearWare.User.
- New function TeamTalkBase.GetUserJitterControl() for retrieving BearWare.JitterConfig on a BearWare.User.
- New variable `%starttick%` for audio file names. See TeamTalkBase.SetUserMediaStorageDir().
- New function TeamTalkBase.SetUserMediaStorageDir() for configuring when an audio log should be closed.
- New struct BearWare.EncryptionContext for setting up peer verification. See Multiple encryption contexts for TeamTalk server.
- New function TeamTalkBase.SetEncryptionContext() for setting up peer verification.
- New function TeamTalkSrvBase.SetEncryptionContextEx() for setting up peer verification on a server.

# TeamTalk 5 SDK v. 5.6a release, August 9th 2020

## New features in v5.6a

### Android sound device for enabling voice communication mode

A new BearWare.SoundDevice will appear on Android when calling TeamTalkBase.GetSoundDevices(). This sound device behaves the same as calling Android Java class android.media.AudioManager.setMode(AudioManager.MODE_IN_COMMUNICATION).

### Enable platform specific sound device effects

Most platforms today come with their own way of toggling effects on a sound device. Examples of this are echo cancellation, automatic gain control (AGC), noise suppression, 3D sound positioning.

BearWare.SoundDevice now has a new property called `uSoundDeviceFeatures` which tells what features can be enabled on the sound device. Currently the list of BearWare.SoundDeviceFeature includes:

- SoundDeviceFeature.SOUNDDEVICEFEATURE_AEC
  - This feature is currently available on Android and on Windows when using SoundSystem.SOUNDSYSTEM_WASAPI.
  - Enable this feature using TeamTalkBase.SetSoundDeviceEffects()
- SoundDeviceFeature.SOUNDDEVICEFEATURE_AGC
  - This feature is currently available on Android and on Windows when using SoundSystem.SOUNDSYSTEM_WASAPI.
  - Enable this feature using TeamTalkBase.SetSoundDeviceEffects()
- SoundDeviceFeature.SOUNDDEVICEFEATURE_DENOISE
  - This feature is currently available on Android and on Windows when using SoundSystem.SOUNDSYSTEM_WASAPI.
  - Enable this feature using TeamTalkBase.SetSoundDeviceEffects()
- SoundDeviceFeature.SOUNDDEVICEFEATURE_3DPOSITION
  - This feature is currently available on Windows when using SoundSystem.SOUNDSYSTEM_DSOUND.
  - Enable this feature using TeamTalkBase.SetUserPosition()
- SoundDeviceFeature.SOUNDDEVICEFEATURE_DUPLEXMODE
  - Enable this feature using TeamTalkBase.InitSoundDuplexDevices()

TeamTalkBase.SetSoundDeviceEffects() is a new function in TeamTalk v5.6 which can be used for enabling AGC, AEC and denoising on Windows and Android.

### Specify sample rate and audio channels for shared sound device

When BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG was introduced the shared sound device would default to a sample rate of 48000 and stereo.

Now it's possible to manually specify the sample rate and number of audio channels using TeamTalkBase.InitSoundInputSharedDevice() and TeamTalkBase.InitSoundOutputSharedDevice().

### Perform sound loopback test using audio preprocessor and sound device effects

When BearWare.AudioPreprocessor was introduced it could not be used when performing a loopback test. This is now possible using TeamTalkBase.StartSoundLoopbackTestEx().

### Sound preprocessor selection

Previously only BearWare.SpeexDSP was available as BearWare.AudioPreprocessor but now others can be chosing using TeamTalkBase.SetSoundInputPreprocessEx().

## API changes in v5.6a

- New macro SoundSystem.SOUNDSYSTEM_AUDIOUNIT_IOS to emphasize AudioUnit for iOS. SoundSystem.SOUNDSYSTEM_COREAUDIO actually also uses AudioUnit.
- New enumeration BearWare.SoundDeviceFeature for listing features that are provided by a BearWare.SoundDevice. See `uSoundDeviceFeatures` on BearWare.SoundDevice.
- New property `nWaveDeviceID` on BearWare.SoundDevice on non-Windows platforms. Previously this property was only shown on Windows but now it's shown on all platform. The reason for this is to have a common structure available for Python integration.
  - Note that this change actually breaks binary compatiblity with TeamTalk v5.5 and previous versions. See Compatibility issue with TeamTalk v5.5 and previous.
- New property `uSoundDeviceFeatures` on BearWare.SoundDevice for showing features available when setting up a sound device.
- New structure BearWare.SoundDeviceEffects for enabling specific effects on a sound device prior to initialization, e.g. echo cancellation.
- Modified macro BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_VOICEPREPROCESSINGIO to include BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG. Previously the iOS sound device that does voice preprocessing actually ran in its own shared device. However, with the introduction of BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG in TeamTalk v5.5 it is simpler for iOS to use the same shared device property as on Android.
  - Note that this change actually breaks binary compatiblity with TeamTalk v5.5 and previous versions.
- New macro BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_OPENSLES_VOICECOM for selecting a BearWare.SoundDevice that uses Android OpenSL ES voice communication mode.
- New macro BearWare.TeamTalkBase.TT_LOCAL_TX_USERID for only getting audio during voice transmission when using TeamTalkBase.EnableAudioBlockEvent().
- Added ClientError.INTERR_AUDIOPREPROCESSOR_INIT_FAILED to ClientError.
- Added ClientError.INTERR_SNDEFFECT_FAILURE to ClientError.
- New function TeamTalkBase.StartSoundLoopbackTestEx() for testing a BearWare.SoundDevice with BearWare.AudioPreprocessor and BearWare.SoundDeviceEffects.
- New function TeamTalkBase.InitSoundInputSharedDevice() for specifying sample rate, frame size and mono/stereo of the input BearWare.SoundDevice that has been initialized with BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG.
- New function TeamTalkBase.InitSoundOutputSharedDevice() for specifying sample rate, frame size and mono/stereo of the output BearWare.SoundDevice that has been initialized with BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG.
- New function TeamTalkBase.SetSoundDeviceEffects() for enabling BearWare.SoundDeviceEffects on a client instance prior to initialization of the BearWare.SoundDevice.
- New function TeamTalkBase.GetSoundDeviceEffects() for getting the BearWare.SoundDeviceEffects on a client instance.
- New function TeamTalkBase.SetSoundInputPreprocessEx() for selecting an BearWare.AudioPreprocessor instead of only BearWare.SpeexDSP in TeamTalkBase.SetSoundInputPreprocess().
- New function TeamTalkBase.GetSoundInputPreprocessEx() for getting the active BearWare.AudioPreprocessor.
- New function TeamTalkBase.EnableAudioBlockEventEx() for requesting BearWare.AudioBlock with the specified BearWare.AudioFormat.

### Compatibility issue with TeamTalk v5.5 and previous

All platforms now include the property `nWaveDeviceID` on BearWare.SoundDevice. Previously this property was only shown on Windows but now it's shown on all platform. This means the byte offset of `bSupports3D` and onwards have changed in the BearWare.SoundDevice structure. The reason for this is to have a common structure available for Python integration.

Value of BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_VOICEPREPROCESSINGIO has been changed to include BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG. Previously the iOS sound device that does voice preprocessing actually ran in its own shared device. However, with the introduction of BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG in TeamTalk v5.5 it is simpler for iOS to use the same shared device property as on Android. Therefore ensure that TeamTalkBase.InitSoundInputDevice() and TeamTalkBase.InitSoundOutputDevice() is not called with 1 instead of the value of BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_VOICEPREPROCESSINGIO.

# TeamTalk 5 SDK v. 5.5a release, April 13 2020

## New features in v5.5a

### Shared audio input/output device

Previously the Android platform only supported one active sound input device. This meant that only one TeamTalk instance could be used on Android.

With the introduction of shared audio device it's now possible for multiple TeamTalk instances to share the same audio input device.

Also for playback the TeamTalk instance can use a shared sound device so playback is not limited to few simultaneous users talking at the same time.

The shared audio device on Android is same as BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_OPENSLES_DEFAULT but or'ed with the flag BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG. The sound device ID flag BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG tells the TeamTalk instance to create a shared audio device which distributes its audio to all other client instances.

The shared audio device which is created runs at the audio device's highest sample rate and highest number of channels. Each client which receives the audio from the shared audio device resamples the audio data to its own format. This is a CPU intensive task, so many clients at different sample rates uses more CPU. It is therefore recommended that clients which use this feature all use channels that has the same audio codec settings. Preferably `nDefaultSampleRate` and `nMaxInputChannels` and `nMaxOutputChannels` of the chosen BearWare.SoundDevice.

To initialize a shared audio input device call like this:

      ttInst.InitSoundInputDevice(ttInst, inputid | SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG);

To initialize a shared audio output device call like this:

      ttInst.InitSoundInputDevice(ttInst, outputid | SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG);

### Playback media file

Media files can now be played using the TeamTalk instance configured sound output device. Call TeamTalkBase.InitLocalPlayback() to playback a media file.

Prior to playback it's possible to set specify an offset using BearWare.MediaFilePlayback and setup an BearWare.AudioPreprocessor.

While the media file is playing it's possible to use TeamTalkBase.UpdateLocalPlayback() to change the media stream's properties. The progress of the media file playback can be monitor through ClientEvent.CLIENTEVENT_LOCAL_MEDIAFILE.

Stop local media file playback using TeamTalkBase.StopLocalPlayback().

### Control media file playback when

streaming to channel

When streaming media files to a channel it's now possible to specify an BearWare.AudioPreprocessor to change the audio stream of the media file.

A new audio BearWare.TTAudioPreprocessor is introduced with can mute left/right audio channel and change gain level.

It's also possible to change the offset and pause the media file using TeamTalkBase.UpdateStreamingMediaFileToChannel() and BearWare.MediaFilePlayback.

To use these new features use TeamTalkBase.StartStreamingMediaFileToChannelEx() instead of TeamTalkBase.StartStreamingMediaFileToChannel().

### nTxIntervalMSec increased to 500 msec

Previously the maximum transmit interval was limited to 100 msec. With BearWare.OpusCodec's introduction of 120 msec frame sizes the transmit interval has been increased to 500 msec.

### OPUS codec frame size selection

OPUS v1.3 introduced additional frame sizes, i.e. 80, 100 and 120 msec. These frame sizes can now be set using the `nFrameSizeMSec` property of BearWare.OpusCodec.

### Access muxed audio stream

Previously TeamTalkBase.EnableAudioBlockEvent() could only be used to access audio from a single user. Using BearWare.TeamTalkBase.TT_MUXED_USERID now makes it possible to access the audio stream where all users' audio streams have been mixed together. Basically the same as recording all conversations to a single file using TeamTalkBase.StartRecordingMuxedAudioFile().

### Inject audio into channel (replace voice input)

The StreamType.STREAMTYPE_VOICE could previously only come from the configured BearWare.SoundDevice passed to TeamTalkBase.InitSoundInputDevice(). Now it's possible to replace the, typically microphone, audio input with a custom audio stream by passing raw audio in BearWare.AudioBlock to TeamTalkBase.InsertAudioBlock().

The audio input must be passed continuesly to TeamTalkBase.InsertAudioBlock() to keep the input going. Use event ClientEvent.CLIENTEVENT_AUDIOINPUT to monitor progress. The BearWare.AudioInputProgress struct hold information about the queue sizes/progress.

### Configure TCP and UDP keep alive properties

How often "keep alive" information should be sent depend on the type of network where the TeamTalk client is deployed. Previously the TCP and UDP keep alive settings have been controlled entirely by the TeamTalk client instance.

Now it's possible to configure the keep alive properties using BearWare.ClientKeepAlive-struct and functions TeamTalkBase.SetClientKeepAlive() and TeamTalkBase.GetClientKeepAlive().

### Record audio from multiple channels

Previously it was only possible to have one active audio recording using TeamTalkBase.StartRecordingMuxedAudioFile().

Now it's possible to record multiple channels at the same time using TeamTalkBase.StartRecordingMuxedAudioFileEx(). Note that in order to get audio from channels where the TeamTalk instance is currently not participating requires the use of TeamTalkBase.DoSubscribe() and Subscription.SUBSCRIBE_INTERCEPT_VOICE.

### Connect to encrypted TeamTalk Professional servers

The TeamTalk 5 SDK Standard Edition could only connect to unencrypted TeamTalk servers, but now it's also possible to connect to encrypted servers. The TeamTalk server in TeamTalk 5 SDK, however, still cannot run in encrypted mode.

### TeamTalk 5 shared C-API library for Android

Previously the Android platform only included a shared library for Java Native Interface (JNI). But now it's also possible to use a shared library like other platforms.

## API changes in v5.5a

- New macro BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_SHARED_FLAG for shared sound input device.
  - See Shared audio input/output device.
- New macro BearWare.TeamTalkBase.TT_MUXED_USERID for TeamTalkBase.EnableAudioBlockEvent().
  - See Access muxed audio stream.
- New macro BearWare.TeamTalkBase.TT_LOCAL_USERID for TeamTalkBase.EnableAudioBlockEvent()
  - See Access muxed audio stream.
- New functions TeamTalkBase.SetClientKeepAlive() and TeamTalkBase.GetClientKeepAlive() for keep alive properties.
  - See Configure TCP and UDP keep alive properties.
- New property `nFrameSizeMSec` for BearWare.OpusCodec.
  - See OPUS codec frame size selection.
- New macro BearWare.OpusConstants.OPUS_MIN_FRAMESIZE for minimum OPUS frame size.
  - See OPUS codec frame size selection and nTxIntervalMSec increased to 500 msec.
- New macro BearWare.OpusConstants.OPUS_MAX_FRAMESIZE for maximum OPUS frame size (OPUS before v1.3)
  - See OPUS codec frame size selection and nTxIntervalMSec increased to 500 msec.
- New macro BearWare.OpusConstants.OPUS_REALMAX_FRAMESIZE for maximum OPUS frame size in OPUS v1.3 and onwards.
  - See OPUS codec frame size selection and nTxIntervalMSec increased to 500 msec.
- New functions TeamTalkBase.InitLocalPlayback(), TeamTalkBase.UpdateLocalPlayback() and TeamTalkBase.StopLocalPlayback() for local media playback.
  - See Playback media file.
- New enumeration values MediaFileStatus.MFS_PAUSED MediaFileStatus.MFS_PLAYING for MediaFileStatus used by ClientEvent.CLIENTEVENT_LOCAL_MEDIAFILE and ClientEvent.CLIENTEVENT_STREAM_MEDIAFILE.
  - See Playback media file and Control media file playback when.
- New enumeration value ClientEvent.CLIENTEVENT_LOCAL_MEDIAFILE for monitoring progress of local media playback.
  - See Playback media file.
- New enumeration BearWare.AudioPreprocessorType for audio preprocessor selection.
  - See Playback media file and Control media file playback when.
- New BearWare.AudioPreprocessor struct for configured audio preprocessor.
  - See Playback media file and Control media file playback when.
- New BearWare.TTAudioPreprocessor struct for TeamTalkBase.InitLocalPlayback() or TeamTalkBase.StartStreamingMediaFileToChannel().
  - See Playback media file and Control media file playback when.
- New function TeamTalkBase.StartStreamingMediaFileToChannel() for streaming media file.
  - See Control media file playback when.
- New function TeamTalkBase.UpdateStreamingMediaFileToChannel() for updating an active media file.
  - See Control media file playback when.
- New BearWare.MediaFilePlayback struct for media file streaming or playback.
  - See Playback media file and Control media file playback when.
- New BearWare.AudioInputProgress struct for monitoring progress when injecting audio.
  - See Inject audio into channel (replace voice input).
- New enumeration value ClientEvent.CLIENTEVENT_AUDIOINPUT for monitoring progress when injecting audio.
  - See Inject audio into channel (replace voice input).
- New function TeamTalkBase.InsertAudioBlock() for injecting audio which replaces microphone input.
  - See Inject audio into channel (replace voice input).
- New function TeamTalkBase.StartRecordingMuxedAudioFile() for recording audio from channel.
  - See Record audio from multiple channels.
- New function TeamTalkBase.StopRecordingMuxedAudioFile() for stopping recording audio from channel.
  - See Record audio from multiple channels.
- New function TeamTalkBase.DBG_WriteAudioFileTone() for generating audio media file.

# TeamTalk 5 SDK v. 5.4a release, June 25th 2019

## New features in v5.4a

TeamTalk SDKs for Android now comes with a TeamTalk JNI library for 64-bit ARM and 32-bit Intel x86. Required API level is now 21 (Android 5.0).

TeamTalk SDKs for Windows now uses Microsoft Media Foundation instead of DirectShow when streaming media files and capturing from video cameras. This means that Windows 10 users can now stream from HTTP and HTTPS.

TeamTalk SDK Standard Edition can now connect to encrypted TeamTalk servers. Running an encrypted TeamTalk server, however, still requires TeamTalk SDK Professional Edition.

TeamTalk SDK Standard Edition can now stream HTTPS on macOS, Android and Linux.

TeamTalk SDK Standard Edition now requires libssl dependency (OpenSSL).

BearWare.Codec.OPUS_CODEC upgraded to v1.3 on all platforms.

Record in MP3 format when using TeamTalkBase.SetUserMediaStorageDir() and TeamTalkBase.StartRecordingMuxedAudioFile().

## API changes in v5.4a

- Added `nLoginDelayMSec` to BearWare.ServerProperties
- Added `szAccessToken` to BearWare.ServerProperties

## Bug fixes in v5.4a

Fixed BearWare.DesktopInput not being received in encrypted mode.

# TeamTalk 5 SDK v. 5.3b release, November 11th 2018

## API changes in v5.3b

The `transmitUsers` array of BearWare.Channel now also applies to ChannelType.CHANNEL_DEFAULT but unlike a channel of type ChannelType.CHANNEL_CLASSROOM the `transmitUsers` array contains the user ID of those who cannot talk. Basically the opposite of classrooms.

The following new macros have been introduced to access the `transmitUsers` array:

- BearWare.TeamTalkBase.TT_CLASSROOM_USERID_INDEX
- BearWare.TeamTalkBase.TT_CLASSROOM_STREAMTYPE_INDEX
- BearWare.TeamTalkBase.TT_TRANSMITUSERS_FREEFORALL
- BearWare.TeamTalkBase.TT_TRANSMITUSERS_USERID_INDEX
- BearWare.TeamTalkBase.TT_TRANSMITUSERS_STREAMTYPE_INDEX

StreamType enumeration now contains:

- StreamType.STREAMTYPE_MEDIAFILE
- StreamType.STREAMTYPE_CLASSROOM_ALL

UserRight enumeration now contains:

- UserRight.USERRIGHT_RECORD_VOICE
- UserRight.USERRIGHT_TRANSMIT_MEDIAFILE

# TeamTalk 5 SDK v. 5.3a release, April 14th 2018

## API changes in v5.3a

- Added BearWare.UserRight to lock nickname: UserRight.USERRIGHT_LOCKED_NICKNAME.
- Added BearWare.UserRight to lock status: UserRight.USERRIGHT_LOCKED_STATUS.
- New BearWare.BanType enumeration to support new ban types on channel and username.
- Added `uBanTypes` to BearWare.BannedUser.
- New BearWare.AbusePrevention structure to BearWare.UserAccount to prevent flooding.
- Added `abusePrevent` to BearWare.UserAccount.
- Added BearWare.ClientError to indicate flooding: ClientError.CMDERR_COMMAND_FLOOD
- Added BearWare.ClientError to indicate channel ban: ClientError.CMDERR_CHANNEL_BANNED
- Added BearWare.ClientError to indicate login service unavailable: ClientError.CMDERR_LOGINSERVICE_UNAVAILABLE.
  - Used for Facebook login in TeamTalk application
- New function TeamTalkBase.DoBanUserEx() for banning a user using BearWare.BanType.
- New function TeamTalkBase.DoBan() for banning properties, i.e. BearWare.BannedUser.
  - User doesn't have to be logged in to issue this ban.
- New function TeamTalkBase.DoUnBanUserEx() for removing a bans.

# TeamTalk 5 SDK v. 5.2d release, June 24th 2017

## Bugfixes in v5.2d

Fixed severe crash issue when audio streams are stopped. Crash was due to a race condition which occurs in rare cases.

# TeamTalk 5 SDK v. 5.2c release, May 8th 2017

## New features in v5.2c

### Virtual sound device

In order to record conversations using TeamTalkBase.StartRecordingMuxedAudioFile() it has previously been required to initialize a real sound output device in order to process audio packets. It is still required to initialize the sound output device but now a new virtual sound device is available which processes audio packets. This virtual sound device has ID BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_TEAMTALK_VIRTUAL.

### Transmission queue in CHANNEL_SOLO_TRANSMIT

A new feature of the BearWare.ChannelType.CHANNEL_SOLO_TRANSMIT channel type is that the server ensures that only one user can transmit audio and media files to the channel. The user's position in the transmission queue can be seen in BearWare.Channel.transmitUsersQueue array.

### Server callbacks for TeamTalkBase.DoChangeNickname() and TeamTalkBase.DoChangeStatus()

The server API can now intercept when a user requests to change nickname or change status. This is done by calling TeamTalk5Srv.UserChangeNickname and TeamTalk5Srv.UserChangeStatus.

### OpenSSL again dynamically linked in Linux distributions

The TeamTalk SDK v5.2b introduced static linking of all dependencies in libTeamTalk5Pro.so but this caused problems when linking an application that already included an OpenSSL dependency. Therefore the Linux distributions now again requires that the user installs the required OpenSSL dependency. To see what OpenSSL dependency is missing run:

      $ ldd Library/TeamTalk_DLL/libTeamTalk5Pro.so

### Daemon scripts included for TeamTalk servers

The SDK's `Server` folder now includes daemon scripts for Debian (`/etc/init`.d) and systemd based Linux distributions.

## API changes in v5.2c

- Added macro for virtual sound device BearWare.SoundDeviceConstants.TT_SOUNDDEVICE_ID_TEAMTALK_VIRTUAL.
- New member variable BearWare.Channel.transmitUsersQueue of BearWare.Channel struct.
- Added macro for size of transmissionUsersQueue BearWare.TeamTalkBase.TT_TRANSMITQUEUE_MAX.
- Added server callback TeamTalk5Srv.OnUserChangeNickname
- Added server callback TeamTalk5Srv.OnUserChangeStatus

### TeamTalk class renamed to TeamTalkBase

Previously the `TeamTalk` class was used by both the Professional and Standard edition of the TeamTalk SDK but from now on the TeamTalk 5 Professional SDK must instantiate BearWare.TeamTalk5Pro class and TeamTalk 5 Standard Edition must instantiate BearWare.TeamTalk5 class. Both BearWare.TeamTalk5 and BearWare.TeamTalk5Pro classes inherit from BearWare.TeamTalkBase.

This change has been made to ensure the distinction between the two SDKs and also to make the .NET API streamlined with the Java API.

# TeamTalk 5 SDK v. 5.2b release, Jan 30th 2017

## API changes in v.5.2b

### TeamTalk Server API for .NET

The TeamTalk server API is now also supported by .NET. Checkout the BearWare.TeamTalk5Srv class which runs the server. To quickly get started it's probably a good idea to checkout TeamTalk .NET Server Example (TeamTalkServer.NET).

## Bugfixes in v5.2b

- Fixed severe issue causing audio playback not to start if client received bursts of audio packets (the client has a 1 second buffer which would overflow and not restart).
- Fixed `nChannelID` not being set in BearWare.User-struct when using TeamTalk Server API.

# TeamTalk 5 SDK v. 5.2a release, January 8th 2017

## New features in v5.2a

### TeamTalk Server API with System ID

The server API has been updated in this release so it's possible to restrict logins to your TeamTalk server to only your own client application. If the "normal" TeamTalk client tries to connect to your TeamTalk server then it will be possible to reject it.

To limit access to your TeamTalk server you can use the `szSystemID` parameter of TeamTalkSrv.StartServerSysID(). When a client has to connect then the chosen system-ID will also have to passed to TeamTalkBase.ConnectSysID(). If it's not then the connecting TeamTalk client will receive the ClientError.CMDERR_INCOMPATIBLE_PROTOCOLS. The szSystemID of the default TeamTalk application is "teamtalk". This is what you see when you connect with Telnet on port TCP port 10333 (non-encrypted).

On top of the system-ID restriction it's now also possible to do a check on the client name connecting by using the extended TeamTalkBase.DoLoginEx(). When a client tries to connect to a TeamTalk server you can then check the `szClientName` property of BearWare.User to ensure only your client application is allowed to connect.

### Voice-Processing I/O Unit for iOS

Audio device "Voice-Processing I/O Unit" added as sound device ID 1 on iOS. The Voice-Processing I/O Unit sound device is designed to eliminate echo when using speaker output and also enable automatic gain control. Read more on audio units here: https://developer.apple.com/library/ios/documentation/MusicAudio/Conceptual/AudioUnitHostingGuide_iOS/UsingSpecificAudioUnits/UsingSpecificAudioUnits.html

### Video4Linux2 (V4L2) support on Linux

The video capture API on Linux has been updated to it now uses V4L2 instead of the obsolete V4L API.

### AVFoundation replaces QTkit on Mac OS

The previously used video capture API, QTkit, on Mac OS has been replaced by AVFoundation. Apple's AppStore doesn't accept apps which link to QTkit, so therefore this replacement was nescessary.

### Dependencies on Linux has been reduced

Previous releases of TeamTalk 5 shared library depended on WebM (libvpx), Speex (libspeex), OPUS (libopus), etc. Now this has been limited to C++ standard library (libstdc++) and ALSA (libasound).

### Sound Preprocessing (Automatic gain control) for iOS

The Speex sound preprocessing library (SpeexDSP) is now also supported on iOS platforms.

The BearWare.SpeexDSP-struct is used by TeamTalkBase.SetSoundInputPreprocess() and TeamTalkBase.StartSoundLoopbackTest().

### TeamTalk for Android now uses Android Studio

Previously the TeamTalk sample application (TeamTalkAndroid) was using Eclipse but this project has now been converted to Android Studio 2.0.

### Store audio in .ogg format

When storing audio to files it's now possible to specify AudioFileFormat.AFF_CHANNELCODEC_FORMAT which is part of the enumeration BearWare.AudioFileFormat. The AudioFileFormat.AFF_CHANNELCODEC_FORMAT will store in the audio format configured by a BearWare.Channel's BearWare.AudioCodec.

## API changes in v5.2a

### Deadline for WebM video encoder

Added `nEncodeDeadline` to BearWare.WebMVP8Codec which specifies quality of the video encoder. Values are BearWare.WebMVP8CodecConstants.WEBM_VPX_DL_REALTIME, BearWare.WebMVP8CodecConstants.WEBM_VPX_DL_GOOD_QUALITY and BearWare.WebMVP8CodecConstants.WEBM_VPX_DL_BEST_QUALITY.

### Get software client used by peer

Added `szClientName` to BearWare.User-struct. The client name is specified in TeamTalkBase.DoLoginEx().

### Limit access to TeamTalk server to one software client

If using TeamTalk 5 SDK Professional then a System-ID can be used to limit access to the TeamTalk server to a single client application.

Use the TeamTalk server API to setup a server with a System-ID, i.e. TTS_StartServerSysID() and then use BearWare.TeamTalkBase.ConnectSysID().

## Bugfixes in v5.2a

- Stream media files was slow to start.
- Streaming media file from Windows caused bottom-up bitmap image.
- Fixed file handle being leaked on Windows during desktop transmission.
- Fixed corrupt .wav file if file greater than 4GB.
- Fixed Bluetooth not working on iOS 10 and later.

# TeamTalk 5 SDK v. 5.1c release, February 29th 2016

The TeamTalk C-API DLL has been moved to `Library/TeamTalk_DLL` The TeamTalk .NET DLL project has been moved to `Library/TeamTalkBase.NET`. The TeamTalk JNI DLL has been moved to `Library/TeamTalkJNI`.

This file layout change has been made so the projects are more aligned with TeamTalk 5 on GitHub.

TeamTalk 5 for iOS application (iTeamTalk) from App Store now included with TeamTalk 5 SDKs for iOS.

TeamTalk 5 Professional SDK now includes TeamTalk 5 Java server sample application (jTeamTalkServer).

## New features in v. 5.1c

TeamTalk 5 iOS SDKs can now be compiled with "Enable Bitcode" (`-fembed-bitcode`).

## API changes in v. 5.1c

Added function TeamTalkBase.PumpMessage() for getting latest BearWare.User-state.

Sound device 1 (speaker output) removed from TeamTalk iOS SDK when calling TeamTalkBase.GetSoundDevices(). Instead use iOS's function `AVAudioSession.setMode()`.

# TeamTalk 5 SDK v. 5.1b release, October 3rd 2015

A quite severe bug which caused files on the server to end up in the wrong channels has been fixed in this minor release. The issue only affects the standalone servers which are included in the SDK. Custom servers created by the TeamTalk server API should not be affected.

## New features in v. 5.1b

### Record own voice stream to separate file

Previously it has only been possible to record own audio streams by subscribing to them. Now it's, however, possible to call TeamTalkBase.SetUserMediaStorageDir() with user ID 0 to record own audio stream.

### TeamTalk JNI DLL for Windows

Windows developers can now also use Java for client development. The TeamTalk JNI DLL is located in `Library/Java/TeamTalkJNI`.

# TeamTalk 5 SDK v. 5.1a release, June 13th 2015

The inclusion of the TeamTalk Server API has caused quite a bit of reorganization of the TeamTalk SDK's file layout. Previously the TeamTalk DLL only allowed client operations and was therefore located in the `Client` folder. Now that the TeamTalk DLL (in the Professional edition) also allows users to develop a TeamTalk server then the core TeamTalk library projects have been moved to the `Library` folder in the root of the SDK.

       Library
         C-API
         Java
         NET
       Documentation
         C-API
         Java
         NET
       Examples
         C-API
         Java
         NET
       Server
       Demo Client

## New Features in v. 5.1a release

### TeamTalk 5 Server API

The TeamTalk 5 Professional Edition now includes a TeamTalk Server API which enables developers to instantiate a TeamTalk server by calling the TeamTalk DLL. With the server API it's possible to do basic operations like authentication users and updating server properties.

Note that the TeamTalk server API is currently only supported in the TeamTalk C-API DLL.

### TeamTalk 5 Java DLL

Now that the TeamTalk SDK is also available for Android the Java API used for Android development has also been ported to Linux and Mac OS X.

Java is supported by using a new TeamTalk DLL with a Java Native Interface (JNI). The TeamTalk JNI DLL is located in `Library/Java/TeamTalkJNI`.

Open the Java documentation to see how to use the new Java API. The Java TeamTalk classes greatly ressemble the .NET classes therefore the API documentation for Java is the same as .NET. Hopefully this doesn't cause too much confusion.

### TeamTalk 5 SDK for iOS

The iOS platform is now also supported by the TeamTalk DLL. Please refer to the C-API on how to use the TeamTalk DLL on iOS.

# TeamTalk 5 SDK v. 5.0a release, March 15th 2015

## New features in v. 5.0a

### Updated event handling

In TeamTalk 4 events were posted in a `TTMessage` containing a WPARAM and LPARAM where the WPARAM would typically contain an ID and the LPARAM some extended information about the event. When an event occured the client application would query the TeamTalk client instance to extract information about what had changed to the current state. Since the client instance was running in its own thread the state change could, however, have become unknown in the meantime. If e.g. a text message was received from a user and the user would immediately quit afterwards then the text message would be lost since the text message was "attached" to the user who was no longer there. In TeamTalk 5 a BearWare.TTMessage now contains a copy of what changed as a cause of the event. If e.g. a text message is received from a user then the BearWare.TTMessage will contain a full copy of the BearWare.TextMessage which was received. Also if a new channel is created then it's no longer required to extract the BearWare.Channel object through the TeamTalk client instance (using TeamTalkBase.GetChannel()) now the new channel is part of the BearWare.TTMessage using the BearWare.TTMessage's data container.

### WebM replaces Theora video codec

Theora video codec was used in TeamTalk 4 to encode video from webcam and media files but this has now been replaced by the more recent Google-backed WebM codec. Check out WebM website for more information about the new video codec. Currently it's only possible to configure the bitrate in the codec but should you need access to more codec configuration options then feel free to request these.

### OPUS replaces CELT audio codec

CELT is no longer being developed and has been replaced by OPUS. Check out OPUS website for more information.

### AES encryption replaces Blowfish

TeamTalk 4 used Blowfish for encrypting audio, video and desktop sharing streams. TeamTalk 5 uses AES 256-bit for encrypting audio, video, media file and desktop sharing streams.

### New stream type for media files

In TeamTalk 4 streaming a media file would replace voice input from microphone and video from a media file would replace webcam input. In TeamTalk 5 a new stream type for media files has been introduced so it's still possible to talk and show webcam video while streaming a media file to a channel.

### User rights now moved to user account

In TeamTalk 4 all users of the default user type had the same user rights on the server which were set up in BearWare.ServerProperties. The user rights (BearWare.UserRight) are now part of BearWare.UserAccount so each user can have different BearWare.UserRight on the server.

### Audio codec bitrate limit moved to user account

The maximum bitrate for audio codecs where global to all users in TeamTalk 4 but now the maximum bitrate a user can use for a new channel is configured in the BearWare.UserAccount.

### Max channels limited to 4000

TeamTalk 4 supported 65000 active channels/rooms but in TeamTalk 5 only 4000 channels are supported. This limited has been implemented to reduce bandwidth usage.

### Peer to peer support has been removed

TeamTalk 5 doesn't support P2P connections since the 'forward through server' is required for desktop sharing to work.

### Channels can be renamed

In TeamTalk 4 is was not possible to update a channel's name but this is now supported. Ensure to update `szInitChannel` of BearWare.UserAccount if you use this feature.

### Daemon script for server included

The TeamTalk 5 Linux server now includes a daemon script which can be put in `/etc/init`.d on Debian to start/stop the TeamTalk daemon (with -d option).

### Audio configuration no longer forced by channel

If a BearWare.Channel was configured with an BearWare.AudioConfig in TeamTalk 4 then the client instance would automatically enable this audio configuration. This is no longer the case in TeamTalk

1. Now the client application must invoke TeamTalkBase.SetSoundInputPreprocess() manually.

### Default server config file renamed to tt5srv.xml

The default name for the server xml configuration file was `tt4svc.xml` in TeamTalk 4 but in TeamTalk 5 it's now `tt5srv.xml` and `tt5prosrv.xml` for the Professional edition.

### Server statistics updated

BearWare.ServerStatistics now includes the number of users served, the highest number of users and server's uptime.

### Non-encrypted mode in Professional server

The TeamTalk server in the Professional SDK (tt5prosrv) now also supports non-encrypted mode. Whether to run in encrypted or non-encrypted mode is configured when running the setup wizard. See more in TeamTalk Server Setup Guide.

## API changes in v. 5.0a

### New structs:

- BearWare.OpusCodec
  - See OPUS replaces CELT audio codec
- BearWare.SpeexDSP
  - See TeamTalkBase.SetSoundInputPreprocess().
- BearWare.OpusConstants
  - Constants for BearWare.OpusCodec.
- BearWare.WebMVP8Codec
  - See WebM replaces Theora video codec
- BearWare.RemoteFile
  - Replacement for `FileInfo`.
- BearWare.ClientErrorMsg
  - Contains information about an error of type BearWare.ClientError.
- BearWare.DesktopInputConstants
  - Constants for BearWare.DesktopInput.
- BearWare.AudioConfigConstants
  - Default values for BearWare.AudioConfig.

### Renamed/modified structs:

- BearWare.SoundDevice
  - `inputSampleRates` and `outputSampleRates` replaced by `supportedSampleRates` due to change of TeamTalkBase.GetSoundDevices() instead of `TeamTalk4.GetSoundInputDevices()` and `TeamTalk4.GetSoundOutputDevices()`.
- BearWare.AudioBlock
  - Now contains `nStreamID`. Stream ID changes whenever push-to-talk or voice activation are toggled.
- BearWare.VideoCaptureDevice
  - `captureFormats` renamed to `videoFormats`.
  - `nCaptureFormatsCount` renamed to `nVideoFormatsCount`.
- BearWare.MediaFileInfo
  - Now contains `szFileName`.
- BearWare.DesktopWindow
  - Now contains `frameBuffer` with pointer to data and `nFrameBufferSize` with size of bffer.
- BearWare.SpeexCodec
  - Renamed `nMSecPerPacket` to nTxIntervalMSec.
  - Removed `bUseJitterBuffer`.
- BearWare.SpeexVBRCodec
  - Renamed `nMSecPerPacket` to nTxIntervalMSec.
  - Renamed `nQualityVBR` to `nQuality`.
  - Removed `bUseJitterBuffer`.
- BearWare.AudioCodec
  - Removed `celt` and `celt_vbr`.
  - Added `opus`, i.e. BearWare.OpusCodec.
- BearWare.AudioConfig
  - Now only contains gain settings. Use BearWare.SpeexDSP for denoising, AEC and AGC.
- BearWare.VideoCodec
  - Removed `theora`.
  - Added `webm_vp8`.
- BearWare.ServerProperties
  - Removed `szServerPasswd`. Only valid BearWare.UserAccount is required now.
  - Removed `uUserRights`. Now part of BearWare.UserAccount.
  - Removed `nAduioCodecBpsLimit`. Now part of BearWare.UserAccount.
  - `nMaxVideoTxPerSecond` replaced by nMaxVideoCaptureTxPerSecond.
  - Added `nMaxMediaFileTxPerSecond`.
- BearWare.ServerStatistics
  - `nVideoBytesTX` replaced by nVideoCaptureBytesTX.
  - `nVideoBytesRX` replaced by nVideoCaptureBytesRX.
  - Added `nMediaFileBytesTX`.
  - Added `nMediaFileBytesRX`.
  - Added `nUsersServed`.
  - Added `nUsersPeak`.
  - Added `nFilesTx`.
  - Added `nFilesRx`.
- BearWare.UserAccount
  - Added `uUserRights`. See User rights now moved to user account.
  - Added `nAudioCodecBpsLimit`. See Audio codec bitrate limit moved to user account.
- BearWare.User
  - Added `nVolumeVoice`.
  - Added `nVolumeMediaFile`.
  - Added `nGainLevelVoice`.
  - Added `nGainLevelMediaFile`.
  - Added `nStoppedDelayVoice`.
  - Added `nStoppedDelayMediaFile`.
  - Added `soundPositionVoice`.
  - Added `soundPositionMediaFile`.
  - Added `stereoPlaybackVoice`.
  - Added `stereoPlaybackMediaFile`.
  - Added `nBufferMSecVoice`
  - Added `nBufferMSecMediaFile`.
  - Renamed `szAudioFolder` to `szMediaStorageDir`
  - Removed `uAFF`. Format in ClientEvent.CLIENTEVENT_USER_RECORD_MEDIAFILE.
  - Removed `szAudioFileName`. File name in ClientEvent.CLIENTEVENT_USER_RECORD_MEDIAFILE.
- BearWare.UserStatistics
  - `nAudioPacketsRecv` replaced by nVoicePacketsRecv.
  - `nAudioPacketsLost` replaced by nVoicePacketsLost.
  - `nVideoPacketsRecv` replaced by nVideoCapturePacketsRecv.
  - `nVideoFramesRecv` replaced by nVideoCaptureFramesRecv.
  - Added `nMediaFileAudioPacketsRecv`.
  - Added `nMediaFileAudioPacketsLost`.
  - Added `nMediaFileVideoPacketsRecv`.
  - Added `nMediaFileVideoFramesRecv`.
  - Added `nMediaFileVideoFramesLost`.
  - Added `nMediaFileVideoFramesDropped`.
- BearWare.Channel
  - Added `nUserData`.
  - Added `transmitUsers`.
  - Renamed `codec` to `audiocodec`.
  - Remove `voiceUsers`. Use `transmitUsers` instead.
  - Remove `videoUsers`. Use `transmitUsers` instead.
  - Remove `desktopUsers`. Use `transmitUsers` instead.
  - Remove `voiceUsers`. Use `transmitUsers` instead.
- BearWare.FileTransfer
  - Added `nStatus`.
- BearWare.TTMessage
  - See Updated event handling.

### Removed structs

- `CELTCodec`
  - See OPUS replaces CELT audio codec
- `TheoraCodec`
  - See WebM replaces Theora video codec
- `FileInfo`
  - Replaced by BearWare.RemoteFile.
- `CaptureFormat`
  - Replaced by BearWare.VideoFormat.

### New enumerations

- StreamType
  - See New stream type for media files

### Renamed/modified enumerations

- `TransmitType`
  - Use BearWare.StreamType instead.
- BearWare.UserRight
  - Added UserRight.USERRIGHT_CREATE_TEMPORARY_CHANNEL. See User rights now moved to user account.
  - Added UserRight.USERRIGHT_MODIFY_CHANNELS. See User rights now moved to user account.
  - Added UserRight.USERRIGHT_KICK_USERS.
  - Added UserRight.USERRIGHT_BAN_USERS.
  - Added UserRight.USERRIGHT_MOVE_USERS.
  - Added UserRight.USERRIGHT_OPERATOR_ENABLE.
  - Added UserRight.USERRIGHT_UPLOAD_FILES.
  - Added UserRight.USERRIGHT_DOWNLOAD_FILES.
  - Added UserRight.USERRIGHT_UPDATE_SERVERPROPERTIES.
  - Added UserRight.USERRIGHT_TRANSMIT_MEDIAFILE_AUDIO. See New stream type for media files.
  - Added UserRight.USERRIGHT_TRANSMIT_MEDIAFILE_VIDEO See New stream type for media files.
  - `USERRIGHT_DOUBLE_LOGIN` replaced by UserRight.USERRIGHT_MULTI_LOGIN.
  - `USERRIGHT_CLIENT_BROADCAST` replaced by UserRight.USERRIGHT_TEXTMESSAGE_BROADCAST.
  - `USERRIGHT_FORWARD_AUDIO` replaced by UserRight.USERRIGHT_TRANSMIT_VOICE
  - `USERRIGHT_FORWARD_VIDEO` replaced by UserRight.USERRIGHT_TRANSMIT_VIDEOCAPTURE
  - `USERRIGHT_FORWARD_DESKTOP` replaced by UserRight.USERRIGHT_TRANSMIT_DESKTOP
  - `USERRIGHT_FORWARD_DESKTOPINPUT` replaced by UserRight.USERRIGHT_TRANSMIT_DESKTOPINPUT
  - Removed `USERRIGHT_CHANNEL_CREATION`. See User rights now moved to user account.
  - Removed `USERRIGHT_CHANNEL_OPERATORS`.
  - Removed `USERRIGHT_CHANNEL_COMMANDS`.
  - Removed `USERRIGHT_SUBSCRIPTIONS`. Subscriptions are now mandatory.
  - Removed `USERRIGHT_STRICT_UTF8`. UTF-8 is now mandatory.
- BearWare.Subscription
  - `SUBSCRIBE_AUDIO` replaced by SUBSCRIBE_VOICE.
  - `SUBSCRIBE_VIDEO` replaced by SUBSCRIBE_VIDEOCAPTURE.
  - `SUBSCRIBE_INTERCEPT_AUDIO` replaced by SUBSCRIBE_INTERCEPT_VOICE.
  - `SUBSCRIBE_INTERCEPT_VIDEO` replaced by SUBSCRIBE_INTERCEPT_VIDEOCAPTURE.
  - Added Subscription.SUBSCRIBE_MEDIAFILE.
  - Added Subscription.SUBSCRIBE_INTERCEPT_MEDIAFILE.
- BearWare.UserState
  - `USERSTATE_TALKING` replaced by UserState.USERSTATE_VOICE.
  - `USERSTATE_MUTE` replaced by UserState.USERSTATE_MUTE_VOICE.
  - `USERSTATE_VIDEO` replaced by UserState.USERSTATE_VIDEOCAPTURE.
  - Added `USERSTATE_MUTE_MEDIAFILE`.
  - Added `USERSTATE_MEDIAFILE_AUDIO`.
  - Added `USERSTATE_MEDIAFILE_VIDEO`.
  - Added `USERSTATE_MEDIAFILE`.
- BearWare.ChannelType
  - `CHANNEL_STATIC` replaced by ChannelType.CHANNEL_PERMANENT.
  - Removed `CHANNEL_ECHO`. Use Subscription.SUBSCRIBE_VOICE instead.
  - Removed `CHANNEL_ECHO_AUDIO`. Use Subscription.SUBSCRIBE_VOICE instead.
  - Removed `CHANNEL_ECHO_VIDEO`. Use Subscription.SUBSCRIBE_VIDEOCAPTURE instead.
  - Removed `CHANNEL_ECHO_DESKTOP`. Use Subscription.SUBSCRIBE_DESKTOP instead.
  - Added ChannelType.CHANNEL_NO_VOICEACTIVATION.
  - Added ChannelType.CHANNEL_NO_RECORDING.
- BearWare.ClientError
  - Removed `CMDERR_INCORRECT_SERVER_PASSWORD`.
  - Removed `CMDERR_CANNOT_CREATE_CHANNELS`.
  - Removed `CMDERR_SUBSCRIPTIONS_DISABLED`.
  - Removed `CMDERR_SERVER_HAS_USERS`.
  - Added ClientError.CMDERR_INVALID_USERNAME.
  - Added ClientError.CMDERR_MAX_CHANNELS_EXCEEDED. See Max channels limited to 4000.
  - Added ClientError.INTERR_AUDIOCODEC_INIT_FAILED.
  - Added ClientError.INTERR_SPEEXDSP_INIT_FAILED.
- BearWare.ClientFlag
  - Added ClientFlag.CLIENT_SNDINPUT_VOICEACTIVE.
  - `CLIENT_TX_AUDIO` replaced by ClientFlag.CLIENT_TX_VOICE.
  - `CLIENT_TX_VIDEO` replaced by ClientFlag.CLIENT_TX_VIDEOCAPTURE.
  - Removed `CLIENT_SNDINPUT_DENOISING`.
  - Removed `CLIENT_P2P_AUDIO`. See Peer to peer support has been removed.
  - Removed `CLIENT_P2P_VIDEO`. See Peer to peer support has been removed.
  - Removed `CLIENT_P2P`. See Peer to peer support has been removed.
  - Removed `CLIENT_SNDINPUT_AEC`.
  - Removed `CLIENT_SNDINPUT_AGC`.
- BearWare.SoundLevel
  - Changed BearWare.SoundLevel `SOUND_VU_MAX` to 100
  - Changed BearWare.SoundLevel `SOUND_VOLUME_MAX` 32000
  - Added BearWare.SoundLevel `SOUND_VOLUME_DEFAULT`

### Removed enumerations:

- `AudioFileStatus`
  - Replaced by BearWare.MediaFileStatus.

### New events:

- BearWare.TeamTalkBase.OnCmdServerStatistics
  - Response to TeamTalkBase.DoQueryServerStats().
- BearWare.TeamTalkBase.OnUserStateChange
  - BearWare.User's state mask `uUserState` changed.
- BearWare.TeamTalkBase.OnUserMediaFileVideo
  - Video frame from media file ready for display.

### Renamed/modified events:

- `TeamTalk4.OnConnectSuccess`
  - Use BearWare.TeamTalkBase.OnConnectionSuccess instead.
- `TeamTalk4.OnConnectFailed`
  - Use BearWare.TeamTalkBase.OnConnectionFailed instead.
- `TeamTalk4.OnCmdProcessing`
  - Use BearWare.TeamTalkBase.OnCmdProcessing instead.
  - `bCompleted` inverted and now states `bActive`.
- `TeamTalk4.OnCmdMyselfLoggedIn`
  - BearWare.UserAccount passed as parameter.
- `TeamTalk4.OnCmdMyselfJoinedChannel`
  - Use BearWare.TeamTalkBase.OnCmdUserJoinedChannel instead.
- `TeamTalk4.OnCmdMyselfLeftChannel`
  - Use BearWare.TeamTalkBase.OnCmdUserLeftChannel instead.
- `TeamTalk4.OnCmdMyselfKickedFromChannel`
  - Use BearWare.TeamTalkBase.OnCmdMyselfKicked instead.
- `TeamTalk4.OnUserTalking`
  - Use BearWare.TeamTalkBase.OnUserStateChange instead.
- `TeamTalk4.OnUserVideoFrame`
  - Use BearWare.TeamTalkBase.OnUserVideoCapture or BearWare.TeamTalkBase.OnUserMediaFileVideo instead.
- `TeamTalk4.OnUserAudioFile`
  - Use BearWare.TeamTalkBase.OnUserRecordMediaFile instead.
- `TeamTalk4.OnDesktopTransferUpdate`
  - Use BearWare.TeamTalkBase.OnDesktopWindowTransfer instead.
- `TeamTalk4.OnUserDesktopCursorPosition`
  - Use BearWare.TeamTalkBase.OnUserDesktopCursor instead.
- `TeamTalk4.OnMaxPayloadUpdate`
  - Use BearWare.TeamTalkBase.OnConnectionMaxPayloadUpdated instead.
- `TeamTalk4.OnStreamAudioFileToChannel`
  - `TeamTalk4.StartStreamingAudioFileToUser()` replaced by BearWare.TeamTalkBase.StartStreamingMediaFileToChannel()
- `TeamTalk4.OnStreamMediaFileChannel`
  - Use BearWare.TeamTalkBase.OnStreamMediaFile instead.

### Removed events

- `TeamTalk4.OnStreamAudioFileToUser`
  - "Outside channel" streaming no longer supported.
- `TeamTalk4.OnConnectionP2P`
  - See Peer to peer support has been removed

### New methods

- BearWare.TeamTalkBase.GetSoundDevices()
  - Replacement for `TeamTalk4.GetSoundInputDevices` and TeamTalk4.GetSoundOutputDevices.
- BearWare.TeamTalkBase.SetSoundInputPreprocess()
  - Replacement for `TeamTalk4.SetAGCSettings` and `TeamTalk4.GetAGCSettings`.
- BearWare.TeamTalkBase.GetSoundInputPreprocess()
  - Replacement for `TeamTalk4.GetAGCSettings`.
- BearWare.TeamTalkBase.EnableVoiceTransmission()
  - Replacement for `TeamTalk4.EnableTransmission`.
- BearWare.TeamTalkBase.StartVideoCaptureTransmission()
  - Replacement for `TeamTalk4.EnableTransmission`.
- BearWare.TeamTalkBase.StopVideoCaptureTransmission()
  - Replacement for `TeamTalk4.EnableTransmission`.
- BearWare.TeamTalkBase.AcquireUserVideoCaptureFrame()
  - Replacement for `TeamTalk4.GetUserVideoFrame` and `TeamTalk4.AcquireUserVideoFrame`.
- BearWare.TeamTalkBase.ReleaseUserVideoCaptureFrame()
  - Replacement for `TeamTalk4.ReleaseUserVideoFrame`.
- BearWare.TeamTalkBase.AcquireUserMediaVideoFrame()
  - See New stream type for media files
- BearWare.TeamTalkBase.ReleaseUserMediaVideoFrame()
  - See New stream type for media files
- BearWare.TeamTalkBase.AcquireUserDesktopWindow()
  - Replacement for BearWare.TeamTalkBase.GetUserDesktopWindow().
- BearWare.TeamTalkBase.AcquireUserDesktopWindowEx()
  - Replacement for BearWare.TeamTalkBase.GetUserDesktopWindow().
- BearWare.TeamTalkBase.ReleaseUserDesktopWindow()
  - Replacement for BearWare.TeamTalkBase.GetUserDesktopWindow().
- BearWare.TeamTalkBase.GetClientStatistics()
  - Replacement for BearWare.TeamTalkBase.GetStatistics().
- BearWare.TeamTalkBase.DoPing()
  - Response using ClientEvent.CLIENTEVENT_CMD_PROCESSING.
- BearWare.TeamTalkBase.GetChannelFile()
  - Replacement for `TeamTalk4.GetChannelFileInfo`
- BearWare.TeamTalkBase.GetMyUserRights()
  - Quick access to own BearWare.UserAccount.
- BearWare.TeamTalkBase.SetUserStoppedPlaybackDelay()
  - Replacement for `TeamTalk4.SetUserStoppedTalkingDelay`
- BearWare.TeamTalkBase.SetUserAudioStreamBufferSize()
  - Replacement for `TeamTalk4.SetUserMediaBufferSize`

### Renamed/modified methods

- BearWare.TeamTalkBase.InitTeamTalk()
  - Now has uMsg parameter `HWND` message identifier.
- BearWare.TeamTalkBase.GetDefaultSoundDevices()
  - Removed lpTTInstance parameter.
- BearWare.TeamTalkBase.StartSoundLoopbackTest()
  - Now returns instance value.
- BearWare.TeamTalkBase.GetVideoCaptureDevices()
  - Removed `lpTTInstance` parameter.
- BearWare.TeamTalkBase.InitVideoCaptureDevice()
  - Removed `lpVideoCodec` parameter.
- BearWare.TeamTalkBase.SendDesktopWindow()
  - `lpBitmap` and `nBitmapSize` are now part of BearWare.DesktopWindow.
- BearWare.TeamTalkBase.SendDesktopCursorPosition()
  - Removed `nUserID` parameter. All in channel will receive.
- BearWare.TeamTalkBase.Connect()
  - Added `bEncrypted` parameter.
- BearWare.TeamTalkBase.ConnectEx()
  - Added `bEncrypted` parameter.
- BearWare.TeamTalkBase.DoLogin()
  - `szServerPassword` removed. User account mandatory in TeamTalk 5.
- BearWare.TeamTalkBase.GetServerUsers()
  - `lpUserIDs` replaced by `lpUsers` parameter.
- BearWare.TeamTalkBase.GetChannelUsers()
  - `lpUserIDs` replaced by `lpUsers` parameter.
- BearWare.TeamTalkBase.GetChannelFiles()
  - `lpFileInfos` replaced by `lpRemoteFiles`
- BearWare.TeamTalkBase.GetServerChannels()
  - `lpChannelIDs` replaced by `lpChannels`.
- BearWare.TeamTalkBase.SetUserVolume()
  - Added `nStreamType` parameter.
- BearWare.TeamTalkBase.SetUserGainLevel()
  - Added `nStreamType` parameter.
- BearWare.TeamTalkBase.SetUserMute()
  - Added `nStreamType` parameter.
- BearWare.TeamTalkBase.EnableAudioBlockEvent()
  - Now requires `nUserID` and `nStreamType`.
- BearWare.TeamTalkBase.AcquireUserAudioBlock()
  - Removed `lpAudioBlock` parameter. Now returns BearWare.AudioBlock.

### Removed methods

- `TeamTalk4.GetSoundInputDevices`
  - Use BearWare.TeamTalkBase.GetSoundDevices() instead.
- `TeamTalk4.GetSoundOutputDevices`
  - Use BearWare.TeamTalkBase.GetSoundDevices() instead.
- `TeamTalk4.StartSoundLoopbackTestEx()`
  - Use BearWare.TeamTalkBase.StartSoundLoopbackTest() instead.
- `TeamTalk4.EnableAGC`
  - Use BearWare.TeamTalkBase.SetSoundInputPreprocess() instead.
- `TeamTalk4.EnableEchoCancellation`
  - Use BearWare.TeamTalkBase.SetSoundInputPreprocess() instead.
- `TeamTalk4.SetAGCSettings`
  - Use BearWare.TeamTalkBase.SetSoundInputPreprocess() instead.
- `TeamTalk4.GetAGCSettings`
  - Use BearWare.TeamTalkBase.GetSoundInputPreprocess() instead.
- `TeamTalk4.EnableDenoising`
  - Use BearWare.TeamTalkBase.SetSoundInputPreprocess() instead.
- `TeamTalk4.SetDenoiseLevel`
  - Use BearWare.TeamTalkBase.SetSoundInputPreprocess() instead.
- `TeamTalk4.GetDenoiseLevel`
  - Use BearWare.TeamTalkBase.GetSoundInputPreprocess() instead.
- `TeamTalk4.GetUserVideoFrame`
  - Use BearWare.TeamTalkBase.AcquireUserVideoCaptureFrame() instead.
- `TeamTalk4.AcquireUserVideoFrame`
  - Use BearWare.TeamTalkBase.AcquireUserVideoCaptureFrame() instead.
- `TeamTalk4.ReleaseUserVideoFrame`.
  - Use BearWare.TeamTalkBase.ReleaseUserVideoCaptureFrame() instead.
- `TeamTalk4.EnableTransmission`
  - Use BearWare.TeamTalkBase.EnableVoiceTransmission() or BearWare.TeamTalkBase.StartVideoCaptureTransmission() instead.
- `TeamTalk4.IsTransmitting`
  - Use BearWare.TeamTalkBase.GetFlags() instead.
- `TeamTalk4.StartStreamingAudioFileToUser`
  - "Outside channel" streaming no longer supported.
- `TeamTalk4.StopStreamingAudioFileToUser`
  - "Outside channel" streaming no longer supported.
- `TeamTalk4.StartStreamingAudioFileToChannel`
  - Use BearWare.TeamTalkBase.StartStreamingMediaFileToChannel() instead.
- `TeamTalk4.StopStreamingAudioFileToChannel`
  - Use BearWare.TeamTalkBase.StopStreamingMediaFileToChannel() instead.
- `BearWare.TeamTalk4.SetUserAudioFolder`
  - Use BearWare.TeamTalkBase.SetUserMediaStorageDir() instead.
- `TeamTalk4.GetUserDesktopCursor`
  - Cursor position posted in ClientEvent.CLIENTEVENT_USER_DESKTOPCURSOR.
- `TeamTalk4.GetUserDesktopInput`
  - BearWare.DesktopInput posted in ClientEvent.CLIENTEVENT_USER_DESKTOPINPUT.
- `TeamTalk4.ConnectNonEncrypted`
  - Use BearWare.TeamTalkBase.Connect() instead.
- `TeamTalk4.SetKeepAliveInterval()`
  - Use BearWare.TeamTalkBase.DoPing() instead.
- `TeamTalk4.GetKeepAliveInterval()`
- `TeamTalk4.SetServerTimeout`
- `TeamTalk4.GetServerTimeout`
- `TeamTalk4.EnablePeerToPeer`
  - See Peer to peer support has been removed
- `TeamTalk4.GetStatistics`
  - Use BearWare.TeamTalkBase.GetClientStatistics() instead.
- `TeamTalk4.GetPacketSize`
- `TeamTalk4.GetServerStatistics`
  - BearWare.ServerStatistics posted in ClientEvent.CLIENTEVENT_CMD_SERVERSTATISTICS.
- `TeamTalk4.GetChannelFileInfo()`
  - Use BearWare.TeamTalkBase.GetChannelFile() instead.
- `TeamTalk4.GetTextMessage()`
  - BearWare.TextMessage posted in ClientEvent.CLIENTEVENT_CMD_USER_TEXTMSG.
- `TeamTalk4.GetUserVolume`
  - Use `nVolumeVoice` in BearWare.User instead.
- `TeamTalk4.GetUserGainLevel`
  - Use `nGainLevelVoice` in BearWare.User instead.
- `TeamTalk4.SetUserStoppedTalkingDelay`
  - Use BearWare.TeamTalkBase.SetUserStoppedPlaybackDelay() instead.
- `TeamTalk4.GetUserStoppedTalkingDelay`
  - Use `nStoppedDelayVoice` in BearWare.User instead.
- `TeamTalk4.GetUserPosition`
  - Use `soundPositionVoice` in BearWare.User instead.
- `TeamTalk4.GetUserStereo`
  - Use `uUserState` in BearWare.User instead.
- `TeamTalk4.SetUserMediaBufferSize`
  - Use BearWare.TeamTalkBase.SetUserAudioStreamBufferSize() instead.
- `TeamTalk4.ReleaseAllAudioBlocks`
  - Use BearWare.TeamTalkBase.ReleaseUserAudioBlock() instead.

# TeamTalk 4 SDK v. 4.6b release, June 28th 2014

The TeamTalk 4 SDK is now also available for Mac OS X 64-bit.

Released on 2014/07/20.

## New features in v. 4.6b

The TeamTalk server now also includes `-l` command line argument for specifying the location of the log-file. Previously only the `-wd` argument could be used for changing the location of the log file.

The log-file of the TeamTalk server now also includes entries for when a user acount is added or deleted and also a log entry for when users are moved between channels.

# TeamTalk 4 SDK v. 4.6a release, February 20th 2014

Released on 2014/02/20.

## New features in v. 4.6a

### Desktop Access

Shared desktops can now be controlled remotely using mouse and keyboard input. Check out Remote Desktop Access to read on how to control remote desktops.

## API Changes in v4.6a

- `BearWare.DesktopInput`
- `BearWare.DesktopKeyState`
- `BearWare.Subscription`
  - Added `Subscription.SUBSCRIBE_DESKTOPINPUT`
- `BearWare.TeamTalk.OnUserDesktopInput`
- `BearWare.UserRight`
  - Added `USERRIGHT_FORWARD_DESKTOPINPUT`
- `BearWare.TeamTalk.SendDesktopInput`
- `BearWare.TeamTalk.GetUserDesktopInput`
- `BearWare.WindowsHelper.KeyTranslate`
- `BearWare.WindowsHelper.Execute`

# TeamTalk 4 SDK v. 4.5a release, May 12th 2013

Released on 2013/05/13.

## New features in v. 4.5a

### Stream Media Files to Channel

Previously it's only been possible to stream 16-bit signed PCM wave-files to a channel but in the 4.5 release it's now possible to stream mp3, mpg, avi, wma, wmv, etc. to a channel. On Windows you can basically stream whatever Windows Media Player can play to a channel. Checkout BearWare.TeamTalk.StartStreamingMediaFileToChannel() for more information.

### Login Attempt Limit

To prevent a brute force login attempt it's now possible to limit the number of login attempt before banning an IP-address. Checkout `nMaxLoginAttempts` property of `BearWare.ServerProperties`. It's now also possible to limit the number of logins per IP-address by specifying `nMaxLoginsPerIPAddress` in `BearWare.ServerProperties`.

### Ban user by IP-address

Previously it was only possible to ban a user's IP-address if the user was present on the server. Now it's, however, possible to ban an IP-address using BearWare.TeamTalk.DoBanIPAddress().

## API Changes in v4.5a

- `BearWare.AudioFormat`
- `BearWare.MediaFileInfo`
- `BearWare.ServerProperties`
  - Added `nMaxLoginAttempts`
  - Added `nMaxLoginsPerIPAddress`
- `BearWare.ClientError`
  - Added `ClientError.CMDERR_MAX_LOGINS_PER_IPADDRESS_EXCEEDED`
- `BearWare.ClientFlag`
  - Added `ClientFlag.CLIENT_STREAM_VIDEO`
  - Added `ClientFlag.CLIENT_STREAM_AUDIO`
- BearWare.TeamTalk.OnStreamMediaFileChannel()
- BearWare.TeamTalk.StartStreamingMediaFileToChannel()
- BearWare.TeamTalk.StopStreamingMediaFileToChannel()
- BearWare.TeamTalk.GetMediaFileInfo()
- BearWare.TeamTalk.DoBanIPAddress()
- BearWare.TeamTalk.SetUserMediaBufferSize()

# TeamTalk 4 SDK v. 4.4a release, September 25th 2012

Released on 2012/10/15.

## New features in v. 4.4a

### Support for Windows Audio Session

Windows Audio Session is a new sound system available in Windows Vista and later versions of Windows. It's a sound system which provides significantly lower latency than both DirectSound and Windows default sound devices. Check out `SoundSystem.SOUNDSYSTEM_WASAPI` for more information.

### Restart Sound System

When the TeamTalk client is initially start it scan the system for all sound devices but if a user later plugs in a USB sound card then this device will not be detected automatically in TeamTalk.GetSoundInputDevices() and TeamTalk.GetSoundOutputDevices().

TeamTalk.RestartSoundSystem() can now be used to shut down the sound systems can rescan for new devices.

### Automatic resampling of unsupported sample rates

If a sound card doesn't support the sampling rate of a codec or if the codec requires stereo input then TeamTalk now automatically resamples audio so it fits the proper format. DirectSound e.g. had problems with input devices which only allowed mono and therefore couldn't be used with stereo codecs.

### Operator receive-only channel type

A new channel type, `BearWare.ChannelType` `CHANNEL_OPERATOR_RECVONLY` has now also been introduced which only allowed administrators and operators of a channel to receive audio and video. This can be useful if bandwidth is a problem.

### Encrypted client (Pro-Edition) can connect to non-encrypted servers

The client in the TeamTalk 4 Professional Edition can now also connect to non-encrypted TeamTalk server. Use TeamTalk.ConnectNonEncrypted() to do this.

### Unicode video device names

`BearWare.VideoCaptureDevice` now shows the name of the video device in Unicode on Windows.

## API Changes in v4.4a

- `BearWare.SoundSystem`
  - Added `SoundSystem.SOUNDSYSTEM_WASAPI`
- `BearWare.SoundDevice`
  - Added `nDefaultSampleRate`
- `BearWare.UserRight`
  - Added `USERRIGHT_STRICT_UTF8`
- `BearWare.ChannelType`
  - Added `ChannelType.CHANNEL_OPERATOR_RECVONLY`
- TeamTalk.GetDefaultSoundDevicesEx()
- TeamTalk.RestartSoundSystem()
- TeamTalk.ConnectNonEncrypted()

# TeamTalk 4 SDK v. 4.3a release, March 18th 2012

Released on 2012/03/26.

## New features in v. 4.3a

### Share Desktop Applications

The major new feature in the 4.3 release is the ability to share desktop applications. When sharing a desktop application you send a bitmap, using TeamTalk.SendDesktopWindow(), to the local client instance. The bitmap is then split into in small blocks and transmitted to the server using the UDP connection. Read more about this feature in the section Desktop Sharing.

### Join channel after login

A `BearWare.UserAccount` now has the `szInitChannel` property which holds the channel a user should join after login. The user can join this channel without passing a password. Use TeamTalk.GetMyUserAccount() to get the local instance's `BearWare.UserAccount` after login has completed.

### Automatically become channel operator

A user can automatically become operator of a `BearWare.Channel` configured with `ChannelType` `CHANNEL_STATIC` if the channel's ID is in the `autoOperatorChannels` property of `BearWare.UserAccount`.

### Custom message type

An extra message type has been added for custom messages. The `TextMsgType` `TextMsgType.MSGTYPE_CUSTOM` works in the same way as `TextMsgType` `TextMsgType.MSGTYPE_USER`.

### Query maximum UDP packet size

Some routers don't allow UDP packets over a given size so use TeamTalk.QueryMaxPayload() after connecting to a server to detect the maximum size for UDP packets. The event TeamTalk.OnMaxPayloadUpdate() is triggered when the client instance has finished querying.

### Access raw audio data

The raw audio, which has been playing when a user is talking, can now be accessed by calling TeamTalk.EnableAudioBlockEvent(). The event TeamTalk.OnUserAudioBlock() is triggered when a new `BearWare.AudioBlock` is available.

### Get name of file being recorded to

If audio files are being recorded separately for every `BearWare.User`, using `TeamTalk.SetUserAudioFolder`, the file name of the file currently being recorded to can be found in the `szAudioFileName` property of the `BearWare.User` struct.

### Reset recorded audio file

To cancel and start recording to a new audio file pass `AudioFileFormat` `AudioFileFormat.AFF_NONE` as parameter to `TeamTalk.SetUserAudioFolder`. This will reset the current recording and generate the TeamTalk.OnUserAudioFile() event.

### See own video stream

A `BearWare.Channel` can now be configured using the `ChannelType` `CHANNEL_ECHO_VIDEO` flag for echoing the video stream transmitted by the local client instance.

### Free-for-all option in classrooms

A `BearWare.Channel` configured using `ChannelType` `ChannelType.CHANNEL_CLASSROOM` was previously limited to 16 people transmitting either video or audio. Now it's, however, possible to add `BearWare.TeamTalk.TT_CLASSROOM_FREEFORALL` to the "enabled" users properties to allow everyone to transmit.

## API Changes in v4.3a

- TeamTalk.EnableAudioBlockEvent()
- TeamTalk.AcquireUserAudioBlock()
- TeamTalk.ReleaseUserAudioBlock()
- TeamTalk.ReleaseAllAudioBlocks()
- TeamTalk.SetUserAudioFolder
  - Added `uAFF` parameter
- TeamTalk.PaintVideoFrameEx()
- TeamTalk.PaintDesktopWindow()
- TeamTalk.PaintDesktopWindowEx()
- TeamTalk.SendDesktopWindow()
- TeamTalk.SendDesktopWindowFromHWND()
- TeamTalk.SendDesktopCursorPosition()
- TeamTalk.CloseDesktopWindow()
- TeamTalk.GetUserDesktopWindow()
- TeamTalk.GetUserDesktopCursor()
- TeamTalk.QueryMaxPayload()
- TeamTalk.Palette_GetColorTable()
- WindowsHelper.GetDesktopActiveHWND()
- WindowsHelper.GetDesktopHWND()
- WindowsHelper.GetDesktopWindowHWND()
- WindowsHelper.GetWindow()
- `BearWare.TeamTalk.OnUserAudioBlock()`
- `BearWare.TeamTalk.OnUserDesktopWindow()`
- `BearWare.TeamTalk.OnDesktopTransferUpdate()`
- `BearWare.TeamTalk.OnUserDesktopCursorPosition()`
- `BearWare.TeamTalk.OnMaxPayloadUpdate()`
- `BearWare.AudioBlock` new struct
- `BitmapFormat` new struct
- `DesktopProtocol` new struct
- `BearWare.DesktopWindow` new struct
- `BearWare.ShareWindow` new struct
- `BearWare.Channel` struct updated with new fields:
  - `desktopUsers`
- `BearWare.ClientStatistics`
  - `nDesktopBytesSent`
  - `nDesktopBytesRecv`
- `BearWare.ServerProperties` struct updated with new fields:
  - `szMOTDRaw`
  - `nMaxDesktopTxPerSecond`.
- `BearWare.UserAccount` struct updated with new fields:
  - `szInitChannel`
  - `autoOperatorChannels`
- `BearWare.User` struct updated with new fields
  - `uAFF`
  - `szAudioFileName`
- `AudioFileFormat` enumeration updated with new values:
  - `AudioFileFormat` `AudioFileFormat.AFF_MP3_16KBIT_FORMAT`
  - `AudioFileFormat` `AudioFileFormat.AFF_MP3_32KBIT_FORMAT`
- `ChannelType` enumeration updated with new values:
  - `ChannelType` `CHANNEL_ECHO_AUDIO`
  - `ChannelType` `CHANNEL_ECHO_VIDEO`
  - `ChannelType` `CHANNEL_ECHO_DESKTOP`
- `ClientFlag`
  - `ClientFlag.CLIENT_DESKTOP_ACTIVE`
  - `ClientFlag.CLIENT_TX_DESKTOP`
- `Subscription` enumeration updated with new values:
  - `Subscription` `Subscription.SUBSCRIBE_CUSTOM_MSG`
  - `Subscription` `Subscription.SUBSCRIBE_INTERCEPT_CUSTOM_MSG`
  - `Subscription` `Subscription.SUBSCRIBE_DESKTOP`
  - `Subscription` `Subscription.SUBSCRIBE_INTERCEPT_DESKTOP`
- `TextMsgType`
  - `TextMsgType` `TextMsgType.MSGTYPE_CUSTOM`
- `UserState` enumeration updated with new values:
  - `UserState` `UserState.USERSTATE_DESKTOP`
  - `UserState` `USERSTATE_VIDEO`
- `UserRight` enumeration updated with new values:
  - `UserRight` `USERRIGHT_FORWARD_DESKTOP`.
- `BearWare.TeamTalk.TT_CLASSROOM_FREEFORALL` new const macro
- `BearWare.TeamTalk.TT_CHANNELS_OPERATOR_MAX` new const macro

# TeamTalk 4 SDK v. 4.2a release, November 1st 2011

Released on 2011/11/02.

## New features in v. 4.2a

### Muxed audio files

It is now possible to store "muxed" audio files, i.e. audio from all users are written to the same audio file. Check out BearWare.StartRecordingMuxedAudioFile() on how to do this.

### Windows XP/Vista/7 Firewall

The Windows Firewall, included in XP and later Windows versions, can sometimes block network traffic to and from applications which uses the TeamTalk DLL. Check out the section Windows Firewall on how to use the Windows Firewall functions.

### Modify "talking" delay

Voice activation is by default disabled if no audio has reached the voice activation level for 1.5 seconds. This option can now be changed by calling TeamTalk.SetVoiceActivationStopDelay(). Also users who are talking are set to non-talking after 0.5 seconds if no new voice data has been received. This value can now be changed by calling TeamTalk.SetUserStoppedTalkingDelay().

### VBR audio codecs

Speex and CELT can now be used in VBR mode by creating a `BearWare.Channel` with the `BearWare.SpeexVBRCodec` or `BearWare.CELTVBRCodec`. To limit bandwidth usage it is advised to use the VBR codecs. Especially the Speex VBR codec with DTX enabled reduces throughput when there's silence.

### CELT updated to version 0.11

CELT 0.5.2, which was used in v 4.1 and previous of the SDK, has been replaced by CELT 0.11. Note that encoding and decoding of CELT 0.5.2 is no longer supported. Check out http://www.celt-codec.org

### IPv6 support (Windows 2000 no longer supported)

Client and server now support IPv6. To make the server run in IPv6 mode the server must bind to an IPv6 address. Check out Configurating the TeamTalk Server on how to specify the bind IP-address (<bind-ip> tag).

Note that the TeamTalk DLL can no longer run on Windows 2000 since this platform does not support IPv6.

## API Changes in v4.2a

- TeamTalk.SetVoiceActivationStopDelay()
- TeamTalk.GetVoiceActivationStopDelay()
- TeamTalk.StartRecordingMuxedAudioFile()
- TeamTalk.StopRecordingMuxedAudioFile()
- TeamTalk.GetServerChannels()
- TeamTalk.SetUserStoppedTalkingDelay()
- TeamTalk.GetUserStoppedTalkingDelay()
- WindowsFirewall.IsEnabled()
- WindowsFirewall.Enable()
- WindowsFirewall.AppExceptionExists()
- WindowsFirewall.AddAppException()
- WindowsFirewall.RemoveAppException()
- `BearWare.SpeexVBRCodec` struct for Speex VBR.
- `BearWare.CELTCodec` struct updated for CELT 0.11.
- `BearWare.CELTVBRCodec` struct for CELT VBR.
- `Codec` enum update with `Codec` `CELT_0_5_2_OBSOLETE_CODEC`, `Codec.SPEEX_VBR_CODEC`, `Codec` `CELT_CODEC` and `Codec` `CELT_VBR_CODEC`.
- `BearWare.AudioCodec` struct updated with VBR codecs.
- `BearWare.ServerProperties` struct updated with `nAudioCodecBpsLimit`, `nMaxAudioTxPerSecond`, `nMaxVideoTxPerSecond` and `nMaxTotalTxPerSecond`.
- `BearWare.ServerStatistics` struct updated with `nUptimeMSec`.
- `AudioFileFormat` enum for different types of audio storage.
- `ClientError` enum now contains `ClientError` `ClientError.CMDERR_UNKNOWN_AUDIOCODEC` for unsupport audio codec and `ClientError` `ClientError.CMDERR_AUDIOCODEC_BITRATE_LIMIT_EXCEEDED` for setting a bitrate for audio codecs which is too high.
- `ClientFlag` enum now contains `ClientFlag.CLIENT_MUX_AUDIOFILE` for active muxed audio file.

# TeamTalk 4 SDK v. 4.1a release, October 30th 2010

Released on 2010/10/30.

## New Features in v. 4.1a release

The new features in the TeamTalk 4 SDK v. 4.1a has are described in the following subsections.

### Removed Microsoft C Runtime dependency

The .NET wrapper for the TeamTalk 4 C-API DLL is now written in C`so` there's no longer a need to include the Microsoft C Runtime files.

### Mac OS X and Windows Mobile platforms

Mac OS X is now supported using the C-API DLL. The C-API DLL is compiled for i386 uses QuickTime for video and CoreAudio for audio. Windows Mobile support is now also supported using both the C-API DLL and the .NET Framework DLL.

### Echo Cancellation

When initializing the client instance's sound system in duplex mode it is now possible to enable echo cancellation. Note, however, that echo cancellation performs poorly on Windows whereas it's very effective on Mac OS X and Linux. Check out BearWare.TeamTalk.InitSoundDuplexDevices() and BearWare.TeamTalk.EnableEchoCancellation() on how to use echo cancellation.

### Classroom channel-type

A new channel-type called classroom has now been introduced where the channel's operator can control who is allowed to transmit audio and video to a channel. The channel operator can then work as sort of a teacher where the teacher selects the people who should answer questions. Check out `BearWare.ChannelType` `ChannelType.CHANNEL_CLASSROOM` for how to create classroom channels.

### Channel based audio configuration

Often users have set their microphones to different audio levels so it's hard to hear certain users and others are too loud. When creating a channel it's now possible to use `BearWare.Channel's` audiocfg member to set the same audio level for all users. Note that all users must use the v. 4.1a release for this to work.

### Server Statistics

Administrators can now query a server statistics using the command BearWare.TeamTalk.DoQueryServerStats() and thereby get an overview of bandwidth usage.

### Simpler video extraction

Using BearWare.TeamTalk.GetUserVideoFrame() is quite tricky to use since the developer must first query for how much memory must be allocated to store the video frame. In this new release it's possible to share memory with the client instance so one simply calls BearWare.TeamTalk.AcquireUserVideoFrame() to get a pointer to a user's video data. when one has completed using the video frame call BearWare.TeamTalk.ReleaseUserVideoFrame() to release the shared memory. Note that only one video frame can be extracted each time, therefore calling BearWare.TeamTalk.AcquireUserVideoFrame() twice will simply result in getting the same video frame.

## API Changes in v4.1a

- `BearWare.TeamTalk.ConnectEx()`
  - This function has now been introduced which allows to specify the IP-address to bind to on the local interface.
- BearWare.TeamTalk.OnCmdSuccess()
  - Whenever the client issues a command to the server (BearWare.TeamTalk.Do* functions) this message will be posted if the command was successful.
- `BearWare.SoundSystem` `SoundSystem.SOUNDSYSTEM_COREAUDIO`
  - Support for Mac OS X sound system.
- BearWare.TeamTalk.InitSoundDuplexDevices()
  - Initialize both sound input and output devices simultaneously. In duplex mode all users' playback streams will be mixed into a single stream. Duplex mode most be enabled if echo cancellation is to be used.
- BearWare.TeamTalk.CloseSoundDuplexDevices()
  - When running in duplex mode this function must be used to close down audio capture and playback.
- BearWare.TeamTalk.StartSoundLoopbackTestEx()
  - Same as BearWare.TeamTalk.StartSoundLoopbackTest() both with `BearWare.AudioConfig` and echo cancellation.
- BearWare.TeamTalk.SetDenoiseLevel()
  - Specify how agressive denoise should be when `BearWare.TeamTalk.EnableDenoising()` is enabled.
- BearWare.TeamTalk.GetDenoiseLevel()
  - Getter for BearWare.TeamTalk.SetDenoiseLevel().
- BearWare.TeamTalk.EnableEchoCancellation()
  - For echo cancellation to be enabled the sound system must have been initialized in duplex mode using BearWare.TeamTalk.InitSoundDuplexDevices(). Note that echo cancellation performs poorly on Windows.
- BearWare.TeamTalk.AcquireUserVideoFrame()
  - Extract a user's video frame in a `BearWare.VideoFrame` struct. Call BearWare.TeamTalk.ReleaseUserVideoFrame() to release the memory referenced in the `BearWare.VideoFrame`.
- BearWare.TeamTalk.ReleaseUserVideoFrame()
  - Release the resources held by the client instance so a new video frame can be extracted. Never use the `BearWare.VideoFrame` from BearWare.TeamTalk.AcquireUserVideoFrame() again after this call.
- `BearWare.AudioConfig`
  - When creating a `BearWare.Channel` using BearWare.TeamTalk.DoMakeChannel() or BearWare.TeamTalk.DoJoinChannel() it is now possible to specify an audio configuration so all users will speak at the same volume level.
- `BearWare.ChannelType` `ChannelType.CHANNEL_CLASSROOM`
  - This is a new channel-type where a channel operator or administrator can select which users are allowed to talk and send video to a channel. Use voiceUsers and videoUsers members of `BearWare.Channel` to select who is allowed to transmit then afterwards call BearWare.TeamTalk.DoUpdateChannel().
- BearWare.TeamTalk.DoChannelOpEx()
  - Make another user operator of a channel by specifying the `BearWare.Channel's` operator password.
- BearWare.TeamTalk.DoQueryServerStats()
  - Ask the server for statistics regarding bandwidth usage.
- BearWare.TeamTalk.GetServerStatistics()
  - After a successful call to BearWare.TeamTalk.DoQueryServerStats() extract the server's statistics in a `BearWare.ServerStatistics` struct.

# TeamTalk 4 SDK v. 4.0c release, March 7th 2010

Released on 2010/03/16.

## New Features in v. 4.0c

The new features in the TeamTalk 4 SDK v. 4.0c has are described in the following subsections.

### Note-field and user-data for user accounts

The `BearWare.UserAccount` struct now has a new member called szNote which can contain extra information about a user account. The `BearWare.UserAccount` and `BearWare.User` structs now also has a nUserData integer field which can be used by developers to store an application specific value. After a successful login the nUserData field on `BearWare.UserAccount` will be transferred to the nUserData field on the `BearWare.User` struct.

### Get "my" User Account

After login it's now possible to retrieve one's own `BearWare.UserAccount` by calling BearWare.TeamTalk.GetMyUserAccount(). BearWare.TeamTalk.GetMyUserData() can be used to extract one's nUserData of one's `BearWare.UserAccount`.

### Extract all Users on the Server

All users who are connected to a server can now be retrieved using BearWare.TeamTalk.GetServerUsers().

## API Changes in v4.0c

The folder for audio storage has now been placed in `BearWare.User` instead of on `BearWare.Channel`. Audio storage is therefore user specific now instead of channel specific.

Renamed/modified functions:

- `BearWare.TeamTalk.SetChannelAudioFolder`
  - Call `BearWare.TeamTalk.SetUserAudioFolder` instead.

## Bug fixes in v. 4.0c

Here a list of bugs fixed in this release:

- Fixed TCP keep-alive timer not starting after connect event
- Improved performance for uploading/downloading files

# TeamTalk 4 SDK v. 4.0a release, November 22nd 2009

Released on 2009/11/23.

## New Features in v. 4.0a

The new features in the TeamTalk 4 SDK v. 4.0a has are described in the following subsections.

### Video Capturing from WebCams

TeamTalk can now capture video from webcams and encode it for transmission. Bandwidth usage can be as low as a 2-3 KBytes/sec in low resolutions. High resultions are, of course, also supported.

To start using the new video features checkout the following new functions:

- Call TeamTalk.GetVideoCaptureDevices() to get a list of available capture devices.
- Call TeamTalk.InitVideoCaptureDevice() to initialize the video capture device.
- Process TeamTalk.OnUserVideoFrame() event.
- Call TeamTalk.EnableTransmission() to transmit video data.

### User Accounts

The TeamTalk server can now be set to only allow users to log on if they have a user account on the server. The user account also introduces user types, so some users can have administrator capabilities.

Read the section Configurating the TeamTalk Server on how to configure the server with user accounts. To see the new functions in the TeamTalk DLL for handling user accounts check out the following new functions:

- Call TeamTalk.DoNewUserAccount() to create a new user account. The user doing this must be administrator, i.e. `UserType` `UserType.USERTYPE_ADMIN`.
- Call TeamTalk.DoDeleteUserAccount() to delete a user account.
- Call TeamTalk.DoListUserAccounts() to list all user accounts on the server.

### Track Command Completion

When calling any of the client to server commands listed in section Client/Server Commands a command ID is returned to the user application. This command ID can be used to track when the server has started and finished processing the command using the TeamTalk.OnCmdProcessing() event.

### Improved P2P Connections

The TeamTalk client now has better support for peer to peer data transmission and can now penetrate most NAT devices.

Check out section REMOVED for more information on P2P networking. P2P networking is enabled using the following functions:

- Call TeamTalk.EnablePeerToPeer() to enable/disable peer to peer connections.

### Support for CELT audio codec

TeamTalk now not only supports the Speex codec, but also the CELT codec. The CELT codec gives much better audio quality but also requires higher bandwidth usage. If a user application is used to transmit music it is advised to use CELT since the sound quality will be must better than Speex. Speex is mainly for voice transmissions. Check out section Audio and Video Codecs to read more about the new codec.

Also note that the audio codec used by a client is now configured on a `BearWare.Channel` and not on each individual client. This means that all users in a channel must now use the same audio settings. This restriction has been set to support echo-cancellation which is on the Known Issues.

## API Changes in v. 4.0a

The COM DLL has been removed from the SDK since most developers used .NET for their client applications. These developers should now use the .NET DLL instead. Here are the changes from the TeamTalk 3 COM DLL to the TeamTalk 4 .NET DLL.

Renamed/modified methods:

- `TeamTalk3` constructor
  - Call TeamTalk.TeamTalk() constructor instead. Input parameter poll_based should be 'false' in Windows Forms applications and 'true' in Console applications.
- `TeamTalk3.DoBroadcastMessage`
  - Call TeamTalk.DoTextMessage() instead with `BearWare.TextMessage` using message type `MSGTYPE_BROADCAST`.
- `TeamTalk3.DoChangeNick`
  - Call TeamTalk.DoChangeNickname()
- `TeamTalk3.DoChannelMessage`
  - Call TeamTalk.DoTextMessage() instead with `BearWare.TextMessage` using message type `MSGTYPE_CHANNEL`.
- `TeamTalk3.DoUserMessage`
  - Call TeamTalk.DoTextMessage() instead with `BearWare.TextMessage` using message type `MSGTYPE_USER`.
- `TeamTalk3.DoUserSubscribe`
  - Call TeamTalk.DoSubscribe()
- `TeamTalk3.DoUserUnsubscribe`
  - Call TeamTalk.DoUnsubscribe()
- `TeamTalk3.GetBytesSent`
  - Call TeamTalk.GetStatistics()
- `TeamTalk3.GetBytesReceived`
  - Call TeamTalk.GetStatistics()
- `TeamTalk3.GetChannelFile`
  - Call TeamTalk.GetChannelFileInfo/(
- `TeamTalk3.GetChannelFileFromIndex`
  - Call TeamTalk.GetChannelFiles()
- `TeamTalk3.GetChannelFilesCount`
  - Call TeamTalk.GetChannelFiles()
- `TeamTalk3.GetCurrentInputLevel`
  - Call TeamTalk.GetSoundInputLevel()
- `TeamTalk3.GetDenoising`
  - Call TeamTalk.GetFlags and check `ClientFlag` `CLIENT_SNDINPUT_DENOISING`.
- `TeamTalk3.GetFileTransfer`
  - Call TeamTalk.GetFileTransferInfo()
- `TeamTalk3.GetForwardToAll`
  - Call TeamTalk.GetFlags and check `ClientFlag` `CLIENT_P2P` is cleared.
- `TeamTalk3.GetInputDeviceCount`
  - Call TeamTalk.GetSoundInputDevices()
- `TeamTalk3.GetInputDeviceName`
  - Call TeamTalk.GetSoundInputDevices()
- `TeamTalk3.GetMasterVolume`
  - Call TeamTalk.GetSoundOutputVolume()
- `TeamTalk3.GetMixerCount`
  - Call WindowsMixer.GetMixerCount()
- `TeamTalk3.GetMixerName`
  - Call WindowsMixer.GetMixerName()
- `TeamTalk3.GetMixerWaveInBoost`
  - Call WindowsMixer.GetWaveInBoost()
- `TeamTalk3.GetMixerWaveInControlCount`
  - Call WindowsMixer.GetWaveInControlCount()
- `TeamTalk3.GetMixerWaveInControlSelected`
  - Call WindowsMixer.GetWaveInControlSelected()
- `TeamTalk3.GetMixerWaveInSelected`
  - Call WindowsMixer.GetWaveInSelected()
- `TeamTalk3.GetMixerWaveInVolume`
  - Call WindowsMixer.GetWaveInVolume()
- `TeamTalk3.GetMixerWaveOutMute`
  - Call WindowsMixer.GetWaveOutMute()
- `TeamTalk3.GetMixerWaveOutVolume`
  - Call WindowsMixer.GetWaveOutVolume()
- `TeamTalk3.GetMuteAll`
  - Call TeamTalk.GetFlags and check `ClientFlag` `CLIENT_SNDOUTPUT_MUTE`.
- `TeamTalk3.GetOutputDeviceCount`
  - Call TeamTalk.GetSoundOutputDevices()
- `TeamTalk3.GetOutputDeviceID`
  - Call TeamTalk.GetSoundOutputDevices()
- `TeamTalk3.GetOutputDeviceName`
  - Call TeamTalk.GetSoundOutputDevices()
- `TeamTalk3.GetTcpKeepAliveInterval`
  - Call TeamTalk.GetKeepAliveInterval()
- `TeamTalk3.GetUserMute`
  - Call TeamTalk.GetUser() and check `BearWare.User's` uUserState flag for `USERSTATE_MUTE`.
- `TeamTalk3.GetVoiceActivated`
  - Call TeamTalk.GetFlags() and check for `ClientFlag` `CLIENT_SNDINPUT_VOICEACTIVATED`.
- `TeamTalk3.GetVoiceGainLevel`
  - Call TeamTalk.GetSoundInputGainLevel()
- `TeamTalk3.InstallTestKeyHook`
  - Call TeamTalk.HotKey_InstallTestHook()
- `TeamTalk3.IsAuthorized`
  - Call TeamTalk.GetFlags() and check for `ClientFlag` `CLIENT_AUTHORIZED`.
- `TeamTalk3.IsConnected`
  - Call TeamTalk.GetFlags() and check for `ClientFlag` `CLIENT_CONNECTED`
- `TeamTalk3.IsConnecting`
  - Call TeamTalk.GetFlags() and check for `ClientFlag` `CLIENT_CONNECTING`
- `TeamTalk3.IsSoundSystemInitialized`
  - Call TeamTalk.GetFlags() and check for `ClientFlag` `CLIENT_SNDNPUT_READY` and `CLIENT_SNDOUTPUT_READY`
- `TeamTalk3.LaunchSoundSystem`
  - Call TeamTalk.InitSoundInputDevice() and TeamTalk.InitSoundOutputDevice()
- `TeamTalk3.RegisterHotKey`
  - Call TeamTalk.HotKey_Register()
- `TeamTalk3.RestartSoundSystem`
  - Call TeamTalk.CloseSoundInputDevice() and TeamTalk.CloseSoundOutputDevice(), then TeamTalk.InitSoundInputDevice() and TeamTalk.InitSoundOutputDevice()
- `TeamTalk3.SetDenoising`
  - Call TeamTalk.EnableDenoising()
- `TeamTalk3.SetForwardToAll`
  - Call TeamTalk.EnablePeerToPeer() with 'false'.
- `TeamTalk3.SetMasterVolume`
  - Call TeamTalk.SetSoundOutputVolume()
- `TeamTalk3.SetMixerWaveInBoost`
  - Call WindowsMixer.SetWaveInBoost()
- `TeamTalk3.SetMixerWaveInControlSelected`
  - Call WindowsMixer.SetWaveInControlSelected()
- `TeamTalk3.SetMixerWaveInSelected`
  - Call WindowsMixer.SetWaveInSelected()
- `TeamTalk3.SetMixerWaveOutMute`
  - Call WindowsMixer.SetWaveOutMute()
- `TeamTalk3.SetMuteAll`
  - Call TeamTalk.SetSoundOutputMute()
- `TeamTalk3.SetTcpKeepAliveInterval`
  - Call TeamTalk.SetKeepAliveInterval()
- `TeamTalk3.SetVoiceActivated`
  - Call TeamTalk.EnableVoiceActivation()
- `TeamTalk3.SetVoiceGainLevel`
  - Call TeamTalk.SetSoundInputGainLevel()
- `TeamTalk3.ShutdownSoundSystem`
  - Call TeamTalk.CloseSoundInputDevice() and TeamTalk.CloseSoundOutputDevice()
- `TeamTalk3.StartTransmitting`
  - Call TeamTalk.EnableTransmission()
- `TeamTalk3.StartTransmittingWaveFile`
  - Call TeamTalk.StartStreamingAudioFileToUser() or TeamTalk.StartStreamingAudioFileToChannel()
- `TeamTalk3.StopTransmitting`
  - Call TeamTalk.EnableTransmission()
- `TeamTalk3.StopTransmittingWaveFile`
  - Call TeamTalk.StopStreamingAudioFileToUser() or TeamTalk.StopStreamingAudioFileToChannel()
- `TeamTalk3.UninstallTestKeyHook`
  - Call TeamTalk.HotKey_RemoveTestHook()
- `TeamTalk3.UnregisterHotKey`
  - Call TeamTalk.HotKey_Unregister()

Removed methods:

- `TeamTalk3.InitTeamTalk`
- `TeamTalk3.CloseTeamTalk`
- `TeamTalk3.SetLocalBindIP` see Known Issues it will be available again.
- `TeamTalk3.GetPlaybackMode`
- `TeamTalk3.GetSamplesPerPacket`
- `TeamTalk3.ProcessMessageQueue`
- `TeamTalk3.RestartSoundSystem`
- `TeamTalk3.SetPlaybackMode`
- `TeamTalk3.RegisterTalkingCallback` see Known Issues it will be available again.
- `TeamTalk3.UnregisterTalkingCallback` see Known Issues it will be available again.

Renamed/modfied events:

- `TeamTalk3.OnAccepted`
  - TeamTalk.OnCmdMyselfLoggedIn()
- `TeamTalk3.OnAddChannel`
  - TeamTalk.OnCmdChannelNew()
- `TeamTalk3.OnAddFile`
  - TeamTalk.OnCmdFileNew()
- `TeamTalk3.OnAddUser`
  - TeamTalk.OnCmdUserJoinedChannel()
- `TeamTalk3.OnBroadcastMessage`
  - TeamTalk.OnCmdUserTextMessage() check `BearWare.TextMessage` for `MSGTYPE_BROADCAST`
- `TeamTalk3.OnChannelMessage`
  - TeamTalk.OnCmdUserTextMessage() check `BearWare.TextMessage` for `MSGTYPE_CHANNEL`
- `TeamTalk3.OnCommandError`
  - TeamTalk.OnCmdError()
- `TeamTalk3.OnFileTransferBegin`
  - TeamTalk.OnFileTransfer()
- `TeamTalk3.OnFileTransferCompleted`
  - TeamTalk.OnFileTransfer()
- `TeamTalk3.OnFileTransferFailed`
  - TeamTalk.OnFileTransfer()
- `TeamTalk3.OnJoinedChannel`
  - TeamTalk.OnCmdMyselfJoinedChannel()
- `TeamTalk3.OnKicked`
  - TeamTalk.OnCmdMyselfKickedFromChannel()
- `TeamTalk3.OnLeftChannel`
  - TeamTalk.OnCmdMyselfLeftChannel()
- `TeamTalk3.OnLoggedOut`
  - TeamTalk.OnCmdMyselfLoggedOut()
- `TeamTalk3.OnRemoveChannel`
  - TeamTalk.OnCmdChannelRemove()
- `TeamTalk3.OnRemoveFile`
  - TeamTalk.OnCmdFileRemove()
- `TeamTalk3.OnRemoveUser`
  - TeamTalk.OnCmdUserLeftChannel()
- `TeamTalk3.OnServerUpdate`
  - TeamTalk.OnCmdServerUpdate()
- `TeamTalk3.OnSoundDeviceError`
  - TeamTalk.OnInternalError()
- `TeamTalk3.OnTestKeyToggle`
  - TeamTalk.OnHotKeyTest()
- `TeamTalk3.OnUpdateChannel`
  - TeamTalk.OnCmdChannelUpdate()
- `TeamTalk3.OnUpdateUser`
  - TeamTalk.OnCmdUserUpdate()
- `TeamTalk3.OnUserLoggedIn`
  - TeamTalk.OnCmdUserLoggedIn()
- `TeamTalk3.OnUserLoggedOut`
  - TeamTalk.OnCmdUserLoggedOut()
- `TeamTalk3.OnUserMessage`
  - TeamTalk.OnCmdUserTextMessage() check `BearWare.TextMessage` for `MSGTYPE_USER`
- `TeamTalk3.OnUserStoppedTalking`
  - TeamTalk.OnUserTalking()
- `TeamTalk3.OnUserTalking`
  - TeamTalk.OnUserTalking()

Removed events:

- `TeamTalk3.OnListCommandCompleted`
- `TeamTalk3.OnUserAudioData` see Known Issues